unit MoveDialog;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, AppObjects, StdCtrls;

type
  TdlgMoveItem = class(TForm)
    btnMoveClose: TButton;
    lblMoveInfo: TLabel;
    procedure btnMoveCloseKeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure FormMouseWheelDown(Sender: TObject; Shift: TShiftState;
      MousePos: TPoint; var Handled: Boolean);
    procedure FormMouseWheelUp(Sender: TObject; Shift: TShiftState;
      MousePos: TPoint; var Handled: Boolean);
  private
    AppToMove: TAppItem;
    MainAppList: TAppItemList;
    { Private declarations }
  public
    function Execute(MainMenuAppList: TAppItemList; intCurrentItem: Integer): Integer;
  end;

var
  dlgMoveItem: TdlgMoveItem;

implementation

{$R *.dfm}

uses main;

procedure TdlgMoveItem.btnMoveCloseKeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if Key = VK_DOWN then
    MainAppList.SortDown(AppToMove.ItemIndex)
  else if Key = VK_UP then
    MainAppList.SortUp(AppToMove.ItemIndex);
end;

function TdlgMoveItem.Execute(MainMenuAppList: TAppItemList; intCurrentItem: Integer): Integer;
begin
  lblMoveInfo.Caption := frmMenu.strMoveDialogText;
  btnMoveClose.Caption := frmMenu.strMoveDlgCancel;
  MainAppList := MainMenuAppList;
  AppToMove := MainMenuAppList[intCurrentItem];
  Caption := AppToMove.Caption;
  ShowModal;
  Result := mrCancel;
end;

procedure TdlgMoveItem.FormMouseWheelDown(Sender: TObject; Shift: TShiftState;
  MousePos: TPoint; var Handled: Boolean);
begin
    MainAppList.SortDown(AppToMove.ItemIndex)
end;

procedure TdlgMoveItem.FormMouseWheelUp(Sender: TObject; Shift: TShiftState;
  MousePos: TPoint; var Handled: Boolean);
begin
    MainAppList.SortUp(AppToMove.ItemIndex);
end;

end.
