{
Copyright 2006-2007 John T. Haller of PortableApps.com

Website: http://PortableApps.com/

This software is OSI Certified Open Source Software.
OSI Certified is a certification mark of the Open Source Initiative.

Please see the included license file for the full details on
all included components.

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

Modified July 8, 2007 by Karl McMurdo (XrXca) to allow dragging the
menu on screen.

}

unit main;

interface

uses Windows, Classes, Forms, StdCtrls, Buttons, ExtCtrls, ComCtrls,
  Jpeg, ShellAPI, Controls, Graphics, Dialogs, SysUtils, INIFiles,
  about, StrUtils, Menus, add_app, Messages, Registry, TypInfo,
  AppObjects, CtgConfig, CommDlg, MoveDialog;

type
  TfrmMenu = class(TForm)

    // === BRANDING ===
    // PortableApps.com logo split into icons to use alpha transparency
    // smaller size used for compatibility with older Windows versions
    // ... part of the upcoming theming system
    imgPortableAppsLogo1: TImage;
    imgPortableAppsLogo2: TImage;
    imgPortableAppsLogo3: TImage;
    imgPortableAppsLogo4: TImage;
    imgPortableAppsLogo5: TImage;
    imgPortableAppsLogo6: TImage;

    // Alternate logo for Windows versions that don't support alpha icons
    imgPortableAppsLogoPixel: TImage;

    // === THEMING ===
    // Only a portion of the upcoming theming engine is contained here
    imgBackground: TImage;
    imgClose: TImage; // not yet used visibly but used as a clickable element
    imgDriveSpace: TImage;

    // === INTERFACE ===
    // Application icons
    sbtnApplication1: TSpeedButton;

    // Scroll buttons for the application icons
    sbtnScrollUp: TSpeedButton;
    sbtnScrollDown: TSpeedButton;

    // Folder and function icons split into buttons and images
    sbtnDocuments: TSpeedButton;
    imgDocuments: TImage;

    sbtnMusic: TSpeedButton;
    imgMusic: TImage;

    sbtnPictures: TSpeedButton;
    imgPictures: TImage;

    sbtnVideo: TSpeedButton;
    imgVideo: TImage;

    sbtnExplore: TSpeedButton;
    imgExplore: TImage;

    imgDivider1: TImage;

    sbtnBackup: TSpeedButton;
    imgBackup: TImage;

    sbtnOptions: TSpeedButton;
    imgOptions: TImage;

    imgDivider2: TImage;
    sbtnSearch: TSpeedButton;
    imgSearch: TImage;

    sbtnHelp: TSpeedButton;
    imgHelp: TImage;

    // Drive name and free space display
    lblDriveName: TLabel;
    lblDriveSpace: TLabel;

    // === POPUP MENUS ===
    pmnuBackup: TPopupMenu;
    pmnuitmBackup: TMenuItem;
    pmnuitmRestore: TMenuItem;

    pmnuOptions: TPopupMenu;
    pmnuitmOptionsSmallFonts: TMenuItem;
    pmnuitmOptionsLargeFonts: TMenuItem;
    pmnuitmOptionsDivider2: TMenuItem;
    pmnuitmOptionsAddApp: TMenuItem;
    pmnuitmOptionsRemoveApp: TMenuItem;
    pmnuitmOptionsGetMore: TMenuItem;
    pmnuitmOptionsRefreshApps: TMenuItem;

    pmnuSearch: TPopupMenu;
    pmnuitmSearchDrive: TMenuItem;
    pmnuitmSearchComputer: TMenuItem;
    pmnuitmSearchWeb: TMenuItem;

    // === TRAY ICON ===
    trayiconMenu: TTrayIcon;

    // === TIMERS ===
    tmrFader: TTimer;
    tmrWatchFocus: TTimer;
    pmnuitmOptionsDivider3: TMenuItem;
    pmnuitmOptionsStayVisible: TMenuItem;
    pmnuitmOptionsDivider0: TMenuItem;
    pmnuitmOptionsLocale: TMenuItem;
    pmnuitmOptionsTheme: TMenuItem;
    pmnuPafData: TPopupMenu;
    pmnuitmPafDataHideApp: TMenuItem;
    pmnuitmPafDataAutoRunApp: TMenuItem;
    pmnuitmPafDataRenameApp: TMenuItem;
    pmnuitmOptionsDivider1: TMenuItem;
    pmnuitmOptionsUnhideApps: TMenuItem;
    pmnuitmPafDataExecOnClose: TMenuItem;
    pmnuCustButtons: TPopupMenu;
    pmnuitmCustButtonsRename: TMenuItem;
    pmnuitmCustButtonsChange: TMenuItem;
    pmnuitmOptionsDivider4: TMenuItem;
    pmnuitmOptionsExit: TMenuItem;
    pmnuitmOptionsDisableFade: TMenuItem;
    pmnuitmOptionsLoadFromDB: TMenuItem;
    pmnuitmOptionsLoadWallpaper: TMenuItem;
    pmnuitmOptionsShowHideMenu: TMenuItem;
    pmnuitmOptionsRestorePosition: TMenuItem;
    pmnuitmOptionsSnapToScreen: TMenuItem;
    N1: TMenuItem;
    pmnuitmPafDataCategory: TMenuItem;
    N2: TMenuItem;
    pmnuitmPafDataAddCategory: TMenuItem;
    pmnuitmPafDataDeleteCategory: TMenuItem;
    pmnuitmPafDataMove: TMenuItem;
    pmnuitmPafDataMoveTop: TMenuItem;
    pmnuitmPafDataMoveUp: TMenuItem;
    pmnuitmPafDataMoveDown: TMenuItem;
    pmnuitmPafDataMoveBottom: TMenuItem;
    pmnuitmOptionsDisableDragging: TMenuItem;
    pmnuitmPafDataExploreHere: TMenuItem;
    tmrAutoScroll: TTimer;
    pmnuitmOptionsSortApps: TMenuItem;
    pmnuitmOptionsSortAlphaSort: TMenuItem;
    pmnuitmOptionsSortAlphaCategoriesFirst: TMenuItem;
    pmnuitmOptionsSortAlphaCategoriesLast: TMenuItem;
    pmnuitmPafDataEditCategory: TMenuItem;
    pmnuitmPafDataRemovefromMenu: TMenuItem;
    pmnuitmOptionsAddExternalApp: TMenuItem;
    opndlgExternalApp: TOpenDialog;
    N3: TMenuItem;
    pmnuitmPafDataMoveUsingKeyboard: TMenuItem;

    // === PROCEDURES ===
    // standard form handlers
    procedure FormCreate(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);

    // Special handlers for clicks of app icons
    procedure AppButtonClick(Sender: TObject);

    // Scrolling the app icon list up or down
    procedure FormMouseWheelUp(Sender: TObject; Shift: TShiftState;
      MousePos: TPoint; var Handled: Boolean);
    procedure FormMouseWheelDown(Sender: TObject; Shift: TShiftState;
      MousePos: TPoint; var Handled: Boolean);
    procedure FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure sbtnScrollUpClick(Sender: TObject);
    procedure sbtnScrollDownClick(Sender: TObject);
    procedure ScrollApps(bolScrollUp: Boolean);

    // Handlers for the folder and function buttons
    procedure sbtnDocumentsClick(Sender: TObject);
    procedure sbtnMusicClick(Sender: TObject);
    procedure sbtnPicturesClick(Sender: TObject);
    procedure sbtnVideoClick(Sender: TObject);
    procedure sbtnExploreClick(Sender: TObject);
    procedure sbtnBackupClick(Sender: TObject);
    procedure sbtnOptionsClick(Sender: TObject);
    procedure sbtnHelpClick(Sender: TObject);
    procedure sbtnSearchClick(Sender: TObject);
    procedure imgCloseClick(Sender: TObject);

    // Tray icon handler
    procedure trayiconMenuClick(Sender: TObject);

    // Display / hide the menu, fade in/out
    procedure FadeInOut(bolFadeInNow: Boolean);
    procedure tmrWatchFocusTimer(Sender: TObject);
    procedure tmrFaderTimer(Sender: TObject);

    // Popup menu handlers
    // Backup popup menu
    procedure pmnuitmBackupClick(Sender: TObject);
    procedure pmnuitmRestoreClick(Sender: TObject);

    // Options popup menu
    procedure pmnuOptionsPopup(Sender: TObject);
    procedure pmnuitmOptionsSmallFontsClick(Sender: TObject);
    procedure pmnuitmOptionsLargeFontsClick(Sender: TObject);
    procedure pmnuitmLocaleClick(Sender: TObject);
    procedure pmnuitmThemeClick(Sender: TObject);
    procedure pmnuitmOptionsAddAppClick(Sender: TObject);
    procedure pmnuitmOptionsRemoveAppClick(Sender: TObject);
    procedure pmnuitmOptionsRefreshAppsClick(Sender: TObject);
    procedure pmnuitmOptionsGetMoreClick(Sender: TObject);
    procedure pmnuitmOptionsStayVisibleClick(Sender: TObject);
    procedure pmnuitmOptionsUnhideAppsClick(Sender: TObject);
    procedure pmnuitmOptionsLoadFromDBClick(Sender: TObject);
    procedure pmnuitmOptionsLoadWallpaperClick(Sender: TObject);
    procedure pmnuitmOptionsRestorePositionClick(Sender: TObject);  // (XrXca)

    // Help popup menu
    procedure pmnuitmSearchWebClick(Sender: TObject);
    procedure pmnuitmSearchComputerClick(Sender: TObject);
    procedure pmnuitmSearchDriveClick(Sender: TObject);

    // App PafData popup menu
    procedure pmnuitmPafDataHideAppClick(Sender: TObject);
    procedure pmnuitmPafDataRenameAppClick(Sender: TObject);
    procedure pmnuitmPafDataAutoRunAppClick(Sender: TObject);
    procedure pmnuitmPafDataExecOnCloseClick(Sender: TObject);

    // Customizable buttons popup menu
    procedure SpeedButtonMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure pmnuitmCustButtonsChangeClick(Sender: TObject);
    procedure pmnuitmCustButtonsRenameClick(Sender: TObject);

    // Setting save and restore functions
    function GetStoredVariable(strVariable: String; strDefault: String) : String;
    function GetStoredSection(strSection: String) : TStringList;
    procedure SetStoredVariable(strVariable: String; strSetting: String);
    procedure SetStoredSection(strSection: String; tstrlstContents: TStringList);

    // Locale and Theme Loaders
    procedure LoadLocale();
    procedure LoadTheme();
    function ThemeShadow: Boolean;

    // Handle global hot-key
    procedure WMHotkey(var msg: TWMHotkey); message WM_HOTKEY;
    procedure pmnuitmOptionsDisableFadeClick(Sender: TObject);

    // Wallpaper functions
    function GetWallpaper() : String;
    function GetWallpaperStyle() : String;
    function GetTileWallpaper() : String;
    procedure SetWallpaper(strFilename, strWallpaperStyle, strTileWallpaper: String);
    procedure pmnuitmOptionsShowHideMenuClick(Sender: TObject);

    // Dynamic image generic click handler
    procedure dynimgCustomImageClick(Sender: TObject);
    procedure CustomImageExitClick(Sender: TObject);

    // Menu Dragging Procedures (XrXca)
    procedure FormMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure OnFormMoving(var Msg: TWMMoving); message WM_MOVING;
    procedure ApplyThemeOffsets;

    // Handle Screens Size Changing
    procedure OnDisplayChange(var Message: TMessage); message WM_DISPLAYCHANGE;
    procedure pmnuitmOptionsSnapToScreenClick(Sender: TObject);
    procedure AppButtonMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure pmnuPafDataPopup(Sender: TObject);
    procedure pmnuitmPafDataMoveTopClick(Sender: TObject);
    procedure pmnuitmPafDataMoveUpClick(Sender: TObject);
    procedure pmnuitmPafDataMoveDownClick(Sender: TObject);
    procedure pmnuitmPafDataMoveBottomClick(Sender: TObject);
    procedure pmnuitmPafDataAddCategoryClick(Sender: TObject);
    procedure pmnuitmPafDataDeleteCategoryClick(Sender: TObject);
    procedure pmnuitmOptionsDisableDraggingClick(Sender: TObject);
    procedure pmnuitmPafDataExploreHereClick(Sender: TObject);
    procedure sbtnScrollDownMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure sbtnScrollUpMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure sbtnScrollUpMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure sbtnScrollDownMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure tmrAutoScrollTimer(Sender: TObject);
    procedure pmnuitmOptionsSortAlphaSortClick(Sender: TObject);
    procedure pmnuitmOptionsSortAlphaCategoriesFirstClick(Sender: TObject);
    procedure pmnuitmOptionsSortAlphaCategoriesLastClick(Sender: TObject);
    procedure pmnuitmPafDataEditCategoryClick(Sender: TObject);
    procedure pmnuitmOptionsAddExternalAppClick(Sender: TObject);
    procedure pmnuitmPafDataRemovefromMenuClick(Sender: TObject);
    procedure pmnuitmPafDataMoveUsingKeyboardClick(Sender: TObject);
    procedure FormHide(Sender: TObject);

  protected
    // Used to add a drop shadow to the menu
    procedure CreateParams(var Params: TCreateParams); override;

  private
    // AppItem List object (handles all sorting adding etc.)
    appList: TAppItemList;

    // tracking variables for the fade timers
    bolFadeIn: boolean; // true if fading in
    bolFadeToExit: boolean; // true if exiting on fade out

    // container variables for drive size, free space size and name
    dblDriveSize: double;
    strDriveSize: string;
    dblDriveFree: double;
    dblDriveUsed: double;
    strDriveFree: string;
    strDriveName: string;

    // tracking variables for permanent visbility support
    bolVisible: Boolean;
    bolFirstRefresh: Boolean;

    // Disable Fade tracking variable
    bolDisableFade: Boolean;

    // Tracking variable for 'LoadAppsFromDB' feature
    bolLoadAppsFromDB: Boolean;

    // Theme & locale name variables
    strTheme: String;
    strIconTheme: String;
    strLocale: String;
    strLocaleVersion: String;
    strTranslator: String;

    // Theme-related tracking variables
    bolSwitchSide: Boolean;
    intOffsetX: Integer;
    intOffsetY: Integer;
    intAppOffsetX: Integer;
    intAppOffsetY: Integer;
    intDefaultOffsetX: Integer; // (XrXca)
    intDefaultOffsetY: Integer; // (XrXca)
    bolForcePixel: Boolean;
    bolForceAlpha: Boolean;
    picOriginalLogo: TPicture;
    imgarrCustomImages: Array of TImage;
    sbtnarrCustomButtons: Array of TSpeedButton;
    bolSeperateAppArrows: Boolean;

    // Customizable Button menu tracker
    objButtonClicked: TObject;

    // Custom Button Exit Link Exe
    strCustomImageExitPath: String;

    // 'CD' mode tracking variable
    bolIsLive: Boolean;

    // Localization strings
    strInstallMessage: String;
    strAppInstallFailed: String;
    strAppRemoveMessage: String;
    strAppRenameMessage: String;
    strRegisterHotkeyError: String;
    strAppInstallButtonOK: String;
    strAppInstallButtonCancel: String;

    strRenameButtonCaption: String;
    strRenameButtonPrompt: String;
    strChangeButtonCaption: String;
    strChangeButtonPrompt: String;
    strHelpDialog: String;
    strFreeOf: String;
    strRenameApp: String;
    strRenameCategory: String;
    strHideApp: String;
    strExternalAppDriveError: String;
    strExternalAppPrompt: String;

    // Theme-related Error Messages
    strDefaultThemeCorrupted: String;
    strSelectedThemeCorrupted: String;

    // Autoscroll Flag
    intAutoScroll: Integer;

    // Wallpaper changer-related strings
    bolLoadWallpaper: Boolean;
    strOriginalWallpaper: String;
    strOriginalWallpaperStyle: String;
    strOriginalWallpaperTiled: String;

    // Internal procedures to handle the buttons, menus and font size
    procedure ChangeMenuFontSize(intFontSize: integer);
    procedure InitButtons(intListLength: Integer);
    procedure SetupButtonsFromDB();
    procedure SetupButtons();
    procedure DisplayButtons();
    procedure SetupMenus();

    // Procedure to handle our 'multiple-instance-opened' message
    function WindowsMessageRecieved(var Msg : TMessage) : Boolean;

    // Function to return offset integers reflecting percentage values
    function OffsetToInt(strInteger : String; intDenominator : Integer) : Integer;
    function RunExe(strExe: string): boolean;

  public
    // public variable for the add app function to pass in the app to install
    strAppToInstall: string;
    // Localization strings accessible by category dialog
    strHideCategory: String;
    strNewCategory: String;
    strCategoryTitle: String;
    strCategoryName: String;
    strCategoryHint: String;
    strCategoryButtonSave: String;
    strCategoryButtonCancel: String;
    strCategoryDriveError: String;
    strOpenChangeCaption: String;
    strOpenResetCaption: String;
    strClosedChangeCaption: String;
    strClosedResetCaption: String;
    strMoveDlgCancel: String;
    strMoveDialogText: String;
  published
    procedure appListChange(Sender: TObject);
    procedure appAfterAppExecute(Sender: TObject);
end;
  TMenuItemExtended = class(TMenuItem)
  private
    fValue: string;
  published
    property Value : string read fValue write fValue;
end;
  TProcedure = procedure of Object;

var
  frmMenu: TfrmMenu;

implementation

{$R *.dfm}

//resourcestring

procedure TfrmMenu.CreateParams(var Params: TCreateParams);
// used to display a drop shadow on the menu on WinXP and up
const
  CS_DROPSHADOW = $00020000;
begin
  inherited;
  if (Win32MajorVersion >= 5) and (Win32MinorVersion >= 1)
            AND (Win32Platform = VER_PLATFORM_WIN32_NT) then
  if ThemeShadow then
    Params.WindowClass.Style := Params.WindowClass.Style or CS_DROPSHADOW;
end;

// =====================================

function TFrmMenu.WindowsMessageRecieved(var Msg : TMessage) : Boolean;
// Handle our custom 'multiple-instance' event
begin
  if Msg.Msg = RegisterWindowMessage(PAnsiChar('IWishMyPortableAppsMenuWouldReappearOnA_NewInstanceCalled'+ParamStr(0))) then
  begin
    FadeInOut(true);
    result := true;
  end
  else
    result := false;
end;

// =====================================

procedure TfrmMenu.OnDisplayChange(var Message: TMessage);
// Handle Changes to Screen Resolution
begin
  ApplyThemeOffsets;
  If frmMenu.Visible then
    FadeInOut(true);
end;

// =====================================

procedure TFrmMenu.WMHotkey(var msg: TWMHotkey);
// Shift-Win hotkey handler
begin
  // Hide window if visible, show if not
  if frmMenu.Visible then
    FadeInOut(false)
  else
    FadeInOut(true);
end;

// =====================================

procedure TFrmMenu.FormCreate(Sender: TObject);
begin
  // Make the working directory the application directory
  SetCurrentDir(ExtractFileDir(Application.ExeName));

  // Insert our message handler
  Application.HookMainWindow(WindowsMessageRecieved);

  appList := TAppItemList.Create;
  appList.OnChanged := appListChange;
  appList.AfterAppExecute := appAfterAppExecute;

  // Initialize AppButton Array
  SetLength(AppList.ButtonsArray, 1);
  AppList.ButtonsArray[0]:=sbtnApplication1;

  imgPortableAppsLogoPixel.Picture.Bitmap.TransparentColor:=clFuchsia;
  picOriginalLogo:=imgPortableAppsLogoPixel.Picture;

  // Create the window hidden and set its properties
  ShowWindow(Application.Handle, SW_HIDE);
  SetWindowLong(Application.Handle, GWL_EXSTYLE,
    GetWindowLong(Application.Handle, GWL_EXSTYLE)
    or WS_EX_TOOLWINDOW );

  // Check to see if our EXE is set to read-only, if so set to 'CD' mode
  // Also, this isn't cross-platform, but it shouldn't be hard to drop in a replacement
  if FileIsReadOnly(ParamStr(0)) then
    bolIsLive:=True
  else
    bolIsLive:=False;

  // Check if 'LoadAppsFromDB' is set to true in the configuration file
  if ansiLowerCase(GetStoredVariable('LoadAppsFromDB', 'false'))='true' then
    bolLoadAppsFromDB:=True;
  pmnuitmOptionsLoadFromDB.Checked:=bolLoadAppsFromDB;

  // Check if wallpaper swapping is enabled
  if ansiLowerCase(GetStoredVariable('LoadWallpaper', 'true'))<>'false' then
  begin
    bolLoadWallpaper:=True;
    pmnuitmOptionsLoadWallpaper.Checked:=True;
  end;

  // Get locale & theme filenames
  strLocale:=GetStoredVariable('Locale', 'English-US.locale');
  strTheme:=GetStoredVariable('Theme', 'default');
  appList.LastSort := TAppSortType(StrToIntDef(GetStoredVariable('SortType', '0'),0));

  // Flag to not show immediately after loading theme
  bolFirstRefresh:=true;

  // Clear Exit Exe Variable
  strCustomImageExitPath := '';

  //Get the original Wallpaper and WallpaperStyle and set up the new one (if avaliable)
  strOriginalWallpaper:='';
  strOriginalWallpaper:=GetWallpaper();
  strOriginalWallpaperStyle:=GetWallpaperStyle();
  strOriginalWallpaperTiled:=GetTileWallpaper();

  // Load Offsets for Moved Menu
  intOffsetX := StrToIntDef(GetStoredVariable('OffsetX','65000'), 65000);
  intOffsetY := StrToIntDef(GetStoredVariable('OffsetY','65000'), 65000);

  // Load Locale & Theme
  LoadLocale();
  LoadTheme();

  if bolLoadAppsFromDB then
    SetupButtonsFromDB
  else
    SetupButtons;
  intAutoScroll := 0;
  appList.AutoExec; // Run Items set to run at startup
  SetupMenus;

  // Register 'show/hide' hotkey. Needs the redundant MOD_SHIFT for some unknown reason
  if not RegisterHotkey(Handle, 1, MOD_WIN or MOD_SHIFT, VK_SHIFT)
     or not RegisterHotkey(Handle, 2, MOD_SHIFT, VK_F11) then
    showmessage(strRegisterHotkeyError);

  // Display the window
//  ShowWindow(Application.Handle, SW_SHOW);

  // Check if 'SnapToScreen' is set to true in the configuration file
  pmnuitmOptionsSnapToScreen.Checked := (ansiLowerCase(GetStoredVariable('SnapToScreen', 'false'))<>'false');
  pmnuitmOptionsDisableDragging.Checked := (ansiLowerCase(GetStoredVariable('DisableDragging', 'false'))<>'false');
  frmMenu.ScreenSnap := pmnuitmOptionsSnapToScreen.Checked;

  // Check if 'DisableFade' is set to true in the configuration file
  if ansiLowerCase(GetStoredVariable('DisableFade', 'false'))<>'false' then
    bolDisableFade:=True;
  pmnuitmOptionsDisableFade.Checked:=bolDisableFade;

  // Now it's ok to show on a theme change
  bolFirstRefresh:=false;
  // Check if 'StartMinimized' is set to true in the configuration file
  if ansiLowerCase(GetStoredVariable('StartMinimized', 'false'))<>'false' then
    FadeInOut(false)
  else
    FadeInOut(true);
  bolFadeToExit:=false;
  // Check if 'LargeFonts' is set to true in the configuration file
  if ansiLowerCase(GetStoredVariable('LargeFonts', 'false'))<>'true' then begin
    pmnuitmOptionsSmallFonts.Checked:=true;
    ChangeMenuFontSize(8);
  end
  else begin
    pmnuitmOptionsLargeFonts.Checked:=true;
    ChangeMenuFontSize(10);
  end;
  // Check if 'StayVisible' is set to true in the configuration file
  if ansiLowerCase(GetStoredVariable('StayVisible', 'false'))='true' then begin
    pmnuitmOptionsStayVisible.Checked:=true;
    bolVisible:=true;
    // Bring to top of all windows, 'Always On Top'
    SetWindowPos(Handle, HWND_TOPMOST, Left, Top, Width, Height, SWP_NOACTIVATE or SWP_NOMOVE or SWP_NOSIZE);
  end;

end;

// =====================================

procedure TfrmMenu.FormDestroy(Sender: TObject);
begin
  // Unregister our Global Hotkeys
  UnregisterHotkey(Handle, 1);
  UnregisterHotkey(Handle, 2);
  // Unhook our message handler
  Application.UnHookMainWindow(WindowsMessageRecieved);

  //Reset the original Wallpaper and WallpaperStyle (if needed)
  if strOriginalWallpaper<>'' then
  begin
    SetWallPaper(strOriginalWallpaper, strOriginalWallpaperStyle, strOriginalWallpaperTiled);
  end;

  // Saving settings if we're NOT running from CD
  if not bolIsLive then
  begin
    // Save our settings
    SetStoredVariable('LargeFonts', BoolToStr(pmnuitmOptionsLargeFonts.Checked, True));
    SetStoredVariable('StayVisible', BoolToStr(pmnuitmOptionsStayVisible.Checked, True));
    SetStoredVariable('Theme', strTheme);
    SetStoredVariable('Locale', strLocale);
    SetStoredVariable('DisableFade', BoolToStr(bolDisableFade, True));
    SetStoredVariable('LoadAppsFromDB', BoolToStr(bolLoadAppsFromDB, True));
    SetStoredVariable('LoadWallpaper', BoolToStr(bolLoadWallpaper, True));
    SetStoredVariable('OffsetX', IntToStr(intOffsetX));
    SetStoredVariable('OffsetY', IntToStr(intOffsetY));
    SetStoredVariable('SnapToScreen', BoolToStr(pmnuitmOptionsSnapToScreen.Checked, True));
    SetStoredVariable('DisableDragging', BoolToStr(pmnuitmOptionsDisableDragging.Checked, True));
    SetStoredVariable('SortType', IntToStr(Ord(appList.LastSort)));
    appList.SaveCategories;
    if appList.Modified then
      if bolLoadAppsFromDB then
        appList.SaveToDB // Save to Default DB
  end;
  // Run ExecOnClose apps
  appList.ExitExec;

  // Run old ExecOnClose batch file
  RunExe(GetStoredVariable('ExecOnClose', 'ExecOnClose.bat'));

  AppList.Free;

  // Clear Exit Exe Variable
  if ( strCustomImageExitPath <> '' )then
    RunExe(strCustomImageExitPath);
end;

procedure TfrmMenu.FormHide(Sender: TObject);
begin
  if dlgMoveItem.Visible then
    dlgMoveItem.btnMoveClose.Click;
end;

// =====================================

procedure TfrmMenu.FormActivate(Sender: TObject);
  var
    iniAutorun: TINIFile;
    strAutorunFilename: string;
begin
  // Position our menu at the bottom right
  // **TODO - Add ability to disable shadow and reposition menu in corner
  if bolSwitchSide then
  begin
    Left:=0+intOffsetX;
    Top:=0+intOffsetY;
  end
  else
  begin
    Left:= Screen.WorkAreaRect.Right-Width+intOffsetX;
    Top:= Screen.WorkAreaRect.Bottom-Height+intOffsetY;
  end;

  // Get the drive's name from the autorun.inf
  strAutorunFilename:= Trim(ExtractFileDrive(ParamStr(0)) + '\autorun.inf');
  iniAutorun:=TINIFile.Create(strAutorunFilename);
  strDriveName := iniAutorun.ReadString('Autorun', 'Label', 'Drive');
  iniAutorun.Free;
  lblDriveName.Caption:=strDriveName + ' (' + ExtractFileDrive(ParamStr(0)) + ')';
end;

// =====================================

procedure TfrmMenu.AppButtonClick(Sender: TObject);
// Special handler for the app button clicks
begin
  appList.AppExecute(TControl(Sender).Tag);
end;

// =====================================

procedure TfrmMenu.AppButtonMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  pmnuPafData.Tag := TControl(Sender).Tag;
  if bolIsLive then
  begin
    pmnuPafData.AutoPopup := False;
  end
  else
  begin
    pmnuPafData.AutoPopup := True;
  end;
end;

procedure TfrmMenu.appListChange(Sender: TObject);
begin
  DisplayButtons;
end;

procedure TfrmMenu.appAfterAppExecute(Sender: TObject);
begin
  if TAppItem(Sender).IsMenu then
    AppList.ShowSubItems(TAppItem(Sender).ItemIndex);
end;

procedure TfrmMenu.ApplyThemeOffsets;
var
  rctMonitor: TRect;
  rctWin: TRect;
  ptPoint: TPoint;
begin
  if ( intOffsetX > 60000 )  then
  begin
    IntOffSetX := intDefaultOffsetX;
    IntOffSetY := intDefaultOffsetY;
    Exit;
  end;
  // Translate
  if not bolSwitchSide then
  begin
    IntOffSetX := IntOffSetX + Screen.WorkAreaWidth - Width;
    intOffsetY := intOffSetY + Screen.WorkAreaHeight - Height;
  end;
  rctWin.Left:= intOffsetX;
  rctWin.Top:= intOffsetY;
  rctWin.Right := intOffsetX + Width;
  rctWin.Bottom := intOffsetY + Height;
  ptPoint.X := intOffsetX + Width div 2;
  ptPoint.Y := intOffsetY + Height div 2;
  rctMonitor := Screen.MonitorFromPoint(ptPoint).WorkareaRect;
  if rctWin.Left < rctMonitor.Left then
    intOffSetX := rctMonitor.Left;
  if rctWin.Top < rctMonitor.Top then
    intOffSetY := rctMonitor.Top;
  if ( rctWin.Right > rctMonitor.Right ) then
    intOffsetX := rctMonitor.Right - Width;
  if rctWin.Bottom > rctMonitor.Bottom then
    intOffSetY := rctMonitor.Bottom - Height;
  if not bolSwitchSide then
  begin
    IntOffSetX := IntOffSetX - Screen.WorkAreaWidth + Width;
    intOffsetY := intOffSetY - Screen.WorkAreaHeight + Height;
  end;
end;

// =====================================

procedure TfrmMenu.FormMouseWheelUp(Sender: TObject; Shift: TShiftState;
  MousePos: TPoint; var Handled: Boolean);
// scroll the menu up when the user scrolls the mouse wheel up over the form
begin
  ScrollApps(true);
end;

// =====================================

procedure TfrmMenu.FormMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
// MouseDown Procedure to enable dragging form (XrXca)
begin
  if not pmnuitmOptionsDisableDragging.Checked then
  begin
    ReleaseCapture;
    SendMessage(frmMenu.Handle, WM_NCLBUTTONDOWN, HTCAPTION, 0);
    // I've never quite figured out why the +2, but it works better than without it (XrXca)
  end;
end;

// =====================================

procedure TfrmMenu.FormMouseWheelDown(Sender: TObject; Shift: TShiftState;
  MousePos: TPoint; var Handled: Boolean);
// scroll the menu down when the user scrolls the mouse wheel down over the form
begin
  ScrollApps(false);
end;

// =====================================

procedure TfrmMenu.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
// catch presses of the up or down arrow as an alternative means of scrolling
var
  I: Integer;
begin
  if HiWord(GetKeyState(VK_UP)) <> 0 then
    ScrollApps(true)
  else
    if HiWord(GetKeyState(VK_DOWN)) <> 0 then
      ScrollApps(false)
  else
    if HiWord(GetKeyState($58)) <> 0 then
    begin
      bolVisible:=false;
      bolFadeToExit:=true;
      FadeInOut(false);
    end else
      if ( Shift = [] ) and ( Key = VK_PRIOR ) then
      begin
        appList.BeginUpdate;
        for I := 1 to Length(AppList.ButtonsArray) do
          ScrollApps(true);
        appList.EndUpdate;
      end else if ( Shift = [] ) and ( Key = VK_NEXT ) then
      begin
        appList.BeginUpdate;
        for I := 1 to Length(AppList.ButtonsArray) do
          ScrollApps(false);
        appList.EndUpdate;
      end else if (shift=([ssCTRL])) then
      begin
        if ( Key = VK_ADD ) or ( MapVirtualKey(Key,2) = $3D ) then
          AppList.ToggleAll(True)
        else if ( Key = VK_SUBTRACT ) or ( MapVirtualKey(Key,2) = $2D ) then
          AppList.ToggleAll(False);
      end;
end;

// =====================================

procedure TfrmMenu.sbtnScrollUpClick(Sender: TObject);
begin
  ScrollApps(true);
end;

procedure TfrmMenu.sbtnScrollUpMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  if ( Button = mbLeft ) then
  begin
    intAutoScroll := -1;
    tmrAutoScroll.Interval := 500;
    tmrAutoScroll.Enabled := True;
  end;
end;

procedure TfrmMenu.sbtnScrollUpMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  tmrAutoScroll.Enabled := False;
end;

// =====================================

procedure TfrmMenu.sbtnScrollDownClick(Sender: TObject);
begin
  ScrollApps(false);
end;

procedure TfrmMenu.sbtnScrollDownMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  if ( Button = mbLeft ) then
  begin
    intAutoScroll := 1;
    tmrAutoScroll.Interval := 500;
    tmrAutoScroll.Enabled := True;
  end;
end;

procedure TfrmMenu.sbtnScrollDownMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  tmrAutoScroll.Enabled := False;
end;

// =====================================

procedure TfrmMenu.ScrollApps(bolScrollUp: Boolean);
// scroll the icon list
begin
  if bolScrollUp then
  begin
    appList.Scroll(-1);
  end else begin
    appList.Scroll(1);
  end;
  if appList.AtTop then
    sbtnScrollUp.Visible:=False
  else
    sbtnScrollUp.Visible:=True;
  if appList.AtBottom then
    sbtnScrollDown.Visible:=False
  else
    sbtnScrollDown.Visible:=True;
end;

// =====================================

procedure TfrmMenu.SpeedButtonMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
// Right click event handler for cust-buttons
begin
  // Don't load the right-click menu if we're on a CD
  if bolIsLive then
    exit;
  // If it's the right mouse button that's been clicked
  if Button = mbRight then
  begin
    objButtonClicked:=Sender;
    pmnuCustButtons.Popup(Mouse.CursorPos.X,Mouse.CursorPos.Y);
  end;
end;

// =====================================

procedure TfrmMenu.sbtnDocumentsClick(Sender: TObject);
// show Windows explorer (open mode) browsing to the Documents folder
begin
  ShellExecute(0,'open', PAnsiChar(ExtractFileDir(ExtractFileDir(ExtractFileDir(ParamStr(0)))) + GetStoredVariable(sbtnDocuments.Name+'_PATH', '\Documents\') +#0), Nil, Nil, SW_SHOW);
end;

// =====================================

procedure TfrmMenu.sbtnMusicClick(Sender: TObject);
// show Windows explorer (open mode) browsing to the Music folder
begin
  ShellExecute(0,'open', PAnsiChar(ExtractFileDir(ExtractFileDir(ExtractFileDir(ParamStr(0)))) + GetStoredVariable(sbtnMusic.Name+'_PATH', '\Documents\Music\') +#0), Nil, Nil, SW_SHOW);
end;

// =====================================

procedure TfrmMenu.sbtnPicturesClick(Sender: TObject);
// show Windows explorer (open mode) browsing to the Pictures folder
begin
  ShellExecute(0,'open', PAnsiChar(ExtractFileDir(ExtractFileDir(ExtractFileDir(ParamStr(0)))) + GetStoredVariable(sbtnPictures.Name+'_PATH', '\Documents\Pictures\') +#0), Nil, Nil, SW_SHOW);
end;

// =====================================

procedure TfrmMenu.sbtnVideoClick(Sender: TObject);
// show Windows explorer (open mode) browsing to the Video folder
begin
  ShellExecute(0,'open', PAnsiChar(ExtractFileDir(ExtractFileDir(ExtractFileDir(ParamStr(0)))) + GetStoredVariable(sbtnVideo.Name+'_PATH', '\Documents\Video\') +#0), Nil, Nil, SW_SHOW);
end;

// =====================================

procedure TfrmMenu.sbtnExploreClick(Sender: TObject);
// show Windows explorer (explorer mode) browsing to the root of the portable device
begin
  ShellExecute(0,'explore', PAnsiChar(ExtractFileDrive(ParamStr(0)) + '\' +#0), Nil, Nil, SW_SHOW);
end;

// =====================================

procedure TfrmMenu.sbtnBackupClick(Sender: TObject);
// show the Backup popup menu
begin
  pmnuBackup.Popup(Mouse.CursorPos.X,Mouse.CursorPos.Y);
end;

// =====================================

procedure TfrmMenu.sbtnOptionsClick(Sender: TObject);
// show the Options popup menu
begin
  // Tell the menu we're activating the menu from the options button
  pmnuOptions.Tag := 1;
  pmnuOptions.Popup(Mouse.CursorPos.X,Mouse.CursorPos.Y);
  pmnuOptions.Tag := 0;
end;

// =====================================

procedure TfrmMenu.sbtnHelpClick(Sender: TObject);
// show the Help popup menu
var
  lngFileInfoSize: Longint;
  dwdFileInfoLength: DWord;
  ptrFileInfo, ptrFileInfoLanguage, ptrFileInfoData: Pointer;
  uintFileInfoDataLength: Uint;
  strFileInfoQuery: String;
  strMessage: String;
begin
  lngFileInfoSize:=GetFileVersionInfoSize(PChar(ParamStr(0)), dwdFileInfoLength);
  if (lngFileInfoSize > 0) then
  begin
    GetMem(ptrFileInfo, lngFileInfoSize);
    try
    // Check if the current app has a ProductName
    if GetFileVersionInfo(PChar(ParamStr(0)), dwdFileInfoLength, lngFileInfoSize, ptrFileInfo) then
    begin
      strFileInfoQuery:='ProductVersion';
      if VerQueryValue(ptrFileInfo,'\VarFileInfo\Translation',ptrFileInfoLanguage, uintFileInfoDataLength) then
        strFileInfoQuery:=Format('\StringFileInfo\%0.4x%0.4x\%s'#0,[LoWord(LongInt(ptrFileInfoLanguage^)),
      HiWord(LongInt(ptrFileInfoLanguage^)), strFileInfoQuery]);
      if VerQueryValue(ptrFileInfo,PChar(strFileInfoQuery),ptrFileInfoData,uintFileInfoDataLength) then
      begin
        strMessage := Format(strHelpDialog, [strPas(ptrFileInfoData), strLocaleVersion]);
        if strTranslator <> '' then
          strMessage := strMessage + #10 + strTranslator;
        ShowMessage(strMessage);
      end;
    end;
    finally
      FreeMem(ptrFileInfo, lngFileInfoSize);
    end;
  end;
end;

// =====================================

procedure TfrmMenu.sbtnSearchClick(Sender: TObject);
// show the search popup menu
begin
  pmnuSearch.Popup(Mouse.CursorPos.X,Mouse.CursorPos.Y);
end;

// =====================================

procedure TfrmMenu.imgCloseClick(Sender: TObject);
// close the application
begin
  bolVisible:=false;
  bolFadeToExit:=true;
  FadeInOut(false);
end;

// =====================================

procedure TfrmMenu.trayiconMenuClick(Sender: TObject);
// show/hide the menu on a tray icon click
begin
  if frmMenu.Visible then begin
    FadeInOut(false);
  end else begin
    FadeInOut(true);
  end;
end;

// =====================================

procedure TfrmMenu.FadeInOut(bolFadeInNow: Boolean);
// fade the menu in or out and recalculate the drive size on a fade in
begin
  if (bolVisible=true) and (bolFadeInNow=false) then
  begin
    // Bring the menu to the foreground instead of fading in
    Application.BringToFront;
    exit;
  end;


  if bolFadeInNow then begin
    // position at the bottom right (or bottom left if side is switched) with space for the shadow
    if bolSwitchSide then
    begin
      Left:=0+intOffsetX;
      Top:=0+intOffsetY;
    end
    else
    begin
      Left:= Screen.WorkAreaRect.Right-Width+intOffsetX;
      Top:= Screen.WorkAreaRect.Bottom-Height+intOffsetY;
    end;

    // calculate and display the drive size
    dblDriveSize := DiskSize(Ord(ParamStr(0)[1]) - $40);
    if dblDriveSize > 1073741824 then
      strDriveSize := FloatToStrF((dblDriveSize/1073741824), ffFixed, 4, 0) + 'GB'
    else
      if dblDriveSize > 1048576 then
        strDriveSize := FloatToStrF((dblDriveSize/1048576), ffFixed, 4, 0) + 'MB'
      else
        if dblDriveSize > 1024 then
          strDriveSize := FloatToStrF((dblDriveSize/1024), ffFixed, 4, 0) + 'KB'
        else
          strDriveSize := FloatToStrF((dblDriveSize), ffFixed, 4, 0) + 'B';

    dblDriveFree := DiskFree(Ord(ParamStr(0)[1]) - $40);
    dblDriveUsed := dblDriveSize - dblDriveFree;

    if dblDriveFree > 1073741824 then
      strDriveFree := FloatToStrF((dblDriveFree/1073741824), ffFixed, 4, 1) + 'GB'
    else
      if dblDriveFree > 1048576 then
        strDriveFree := FloatToStrF((dblDriveFree/1048576), ffFixed, 4, 1) + 'MB'
      else
        if dblDriveUsed > 1024 then
          strDriveFree := FloatToStrF((dblDriveFree/1024), ffFixed, 4, 1) + 'KB'
        else
          strDriveFree := FloatToStrF((dblDriveFree), ffFixed, 4, 1) + 'B';

    lblDriveSpace.Caption:= strDriveFree + ' ' + strFreeOf + ' ' + strDriveSize;
    imgDriveSpace.Width:=round(dblDriveUsed/dblDriveSize*131);

    // set the appropriate hint
    trayiconMenu.Hint := 'Portable Apps Menu (Click to hide the menu)';

    // fade in now
    bolFadeIn:= True;
    tmrFader.Enabled:= True;
    frmMenu.Show;
    SetFocus;
    SetActiveWindow(Handle);
    SetForegroundWindow(Handle);
  end else begin // fade the menu out
    trayiconMenu.Hint := 'Portable Apps Menu (Click to show the menu)';
    bolFadeIn:= False;
    tmrFader.Enabled:= True;
  end;
end;

// =====================================

procedure TfrmMenu.tmrWatchFocusTimer(Sender: TObject);
begin
  if (getFocus() = 0) and (bolVisible = False) then FadeInOut(False);
end;

// =====================================

procedure TfrmMenu.tmrAutoScrollTimer(Sender: TObject);
begin
  tmrAutoScroll.Enabled := False;
  if Abs(intAutoScroll) = 1 then
  begin
    tmrAutoScroll.Interval := 150;
  end else if Abs(intAutoScroll) = 5 then
  begin
    tmrAutoScroll.Interval := 80;
  end;
  if ( intAutoScroll < 0 ) then
  begin
    Dec(intAutoScroll);
    ScrollApps(True);
    if not appList.AtTop then
      tmrAutoScroll.Enabled := True;
  end else begin
    Inc(intAutoScroll);
    ScrollApps(False);
    if not appList.AtBottom then
      tmrAutoScroll.Enabled := True;
  end;
end;

procedure TfrmMenu.tmrFaderTimer(Sender: TObject);
// adjust the alpha values to fade the menu in or out
begin
  if bolDisableFade then
  begin
    tmrFader.Enabled:= False;
    if BolFadeIn then
    begin
      frmMenu.AlphaBlendValue := 255;
    end
    else
    begin
      frmMenu.AlphaBlendValue := 0;
      frmMenu.Hide;
      if bolFadeToExit then // Exit the app on fade out if set to
      begin
        Close;
      end;
    end;
    exit;
  end;

  if bolFadeIn then
  begin
    if frmMenu.AlphaBlendValue < 225 then
    begin
      frmMenu.AlphaBlendValue := frmMenu.AlphaBlendValue + 30;
    end else begin
      frmMenu.AlphaBlendValue := 255;
      tmrFader.Enabled:= False;
    end;
  end else begin
    if frmMenu.AlphaBlendValue > 30 then
    begin
      frmMenu.AlphaBlendValue := frmMenu.AlphaBlendValue - 30;
    end else begin
      frmMenu.AlphaBlendValue := 0;
      frmMenu.Hide;
      tmrFader.Enabled:= False;
      if bolFadeToExit then // Exit the app on fade out if set to
      begin
        Close;
      end;
    end;
  end;
end;

// =====================================

procedure TfrmMenu.pmnuitmBackupClick(Sender: TObject);
// Start PortableApps Backup
begin
  ShellExecute(0,'open', PAnsiChar(ExtractFileDir(ExtractFileDir(ParamStr(0))) + '\PortableAppsBackup\PortableAppsBackup.exe'), Nil, Nil, SW_SHOWNORMAL);
end;

// =====================================

procedure TfrmMenu.pmnuitmCustButtonsChangeClick(Sender: TObject);
var
  strName: String;
  strDefault: String;
begin
  strName:=TSpeedButton(objButtonClicked).Name;
  if strName='sbtnDocuments' then
    strDefault:=GetStoredVariable(strName+'_PATH', '\Documents\')
  else if strName='sbtnMusic' then
    strDefault:=GetStoredVariable(strName+'_PATH', '\Documents\Music')
  else if strName='sbtnPictures' then
    strDefault:=GetStoredVariable(strName+'_PATH', '\Documents\Pictures')
  else if strName='sbtnVideo' then
    strDefault:=GetStoredVariable(strName+'_PATH', '\Documents\Video');
  SetStoredVariable(strName+'_PATH', InputBox(strChangeButtonCaption, strChangeButtonPrompt, strDefault));
end;

// =====================================

procedure TfrmMenu.pmnuitmCustButtonsRenameClick(Sender: TObject);
var
  strName: String;
  strDefault: String;
begin
  strName:=TSpeedButton(objButtonClicked).Name;
  strDefault:=TSpeedButton(objButtonClicked).Caption;
  SetStoredVariable(strName+'_NAME', InputBox(strRenameButtonCaption, strRenameButtonPrompt, strDefault));
  DisplayButtons;
end;

// =====================================

procedure TfrmMenu.pmnuitmRestoreClick(Sender: TObject);
// Start PortableApps Backup - Restore
begin
  ShellExecute(0,'open', PAnsiChar(ExtractFileDir(ExtractFileDir(ParamStr(0))) + '\PortableAppsBackup\PortableAppsBackupRestore.exe'), Nil, Nil, SW_SHOWNORMAL);
end;

// =====================================

procedure TfrmMenu.pmnuitmOptionsStayVisibleClick(Sender: TObject);
// Force the menu to stay visible
begin
  if pmnuitmOptionsStayVisible.Checked then begin
    pmnuitmOptionsStayVisible.Checked:=false;
    bolVisible:=false;
    // Bring to foreground, undo 'Always On Top'
    SetWindowPos(Handle, HWND_TOP, Left, Top, Width, Height, SWP_NOACTIVATE or SWP_NOMOVE or SWP_NOSIZE);
  end
  else begin
    pmnuitmOptionsStayVisible.Checked:=true;
    bolVisible:=true;
    // Bring to top of all windows, 'Always On Top'
    SetWindowPos(Handle, HWND_TOPMOST, Left, Top, Width, Height, SWP_NOACTIVATE or SWP_NOMOVE or SWP_NOSIZE);
  end;
end;

// =====================================

procedure TfrmMenu.pmnuitmOptionsUnhideAppsClick(Sender: TObject);
// Unhide all apps, just a really simple toggle & refresh here
begin
  if pmnuitmOptionsUnhideApps.Checked then
    pmnuitmOptionsUnhideApps.Checked:=False
  else
    pmnuitmOptionsUnhideApps.Checked:=True;
  appList.BeginUpdate;
  appList.ShowAll := pmnuitmOptionsUnhideApps.Checked;
  AppList.ButtonsArray[0].Tag := 0; // force to top of list
  appList.EndUpdate;
end;

// =====================================

procedure TfrmMenu.pmnuitmPafDataAddCategoryClick(Sender: TObject);
var
  strCtgName: String;
  App: TAppItem;
begin
  strCtgName := InputBox(strNewCategory, strCategoryName, '');
  if strCtgName <> '' then
  begin
    AppList.BeginUpdate;
    App := AppList.Apps[AppList.AddCategory(strCtgName, strCtgName, '', True, 0, AppList.DefaultIconPath, AppList.DefaultOpenIconPath)];
    AppList.FixLevels;
    AppList.ReSort;
    AppList.ForceVisible(App.ItemIndex);
    AppList.SaveCategories;
    AppList.EndUpdate;
  end;
end;

procedure TfrmMenu.pmnuitmPafDataAutoRunAppClick(Sender: TObject);
// Edit the paf-data file to autorun the app on startup
var
  intItem: Integer;
begin
  if bolIsLive then
    exit;
  intItem := pmnuPafData.Tag;
  appList.Apps[intItem].AutoExec := not appList.Apps[intItem].AutoExec;
end;

procedure TfrmMenu.pmnuitmPafDataDeleteCategoryClick(Sender: TObject);
begin
  appList.BeginUpdate;
  appList.DelCategory(pmnuPafData.Tag);
  AppList.SaveCategories;
  appList.EndUpdate;
end;

// =====================================

procedure TfrmMenu.pmnuitmPafDataEditCategoryClick(Sender: TObject);
var
  intItem: Integer;
begin
  if bolIsLive then
    exit;
  intItem := pmnuPafData.Tag;
  if dlgCtgConfig.Execute(appList, intItem) = mrOk then
    DisplayButtons;
end;

procedure TfrmMenu.pmnuitmPafDataExecOnCloseClick(Sender: TObject);
var
  intItem: Integer;
begin
  if bolIsLive then
    exit;
  intItem := pmnuPafData.Tag;
  appList.Apps[intItem].ExecOnClose := not appList.Apps[intItem].ExecOnClose;
end;

procedure TfrmMenu.pmnuitmPafDataExploreHereClick(Sender: TObject);
var
  intItem: Integer;
begin
  intItem := pmnuPafData.Tag;
  ShellExecute(0,'explore', PAnsiChar(ExtractFilePath(appList.Apps[intItem].ExePath)), Nil, Nil, SW_SHOW);
end;

// =====================================

procedure TfrmMenu.pmnuitmPafDataHideAppClick(Sender: TObject);
// Edit the paf-data file to hide the app
var
  intItem: Integer;
begin
  if bolIsLive then
    exit;
  intItem := pmnuPafData.Tag;
  if not appList.ShowAll then appList.BeginUpdate;
  appList.Apps[intItem].Visible := not appList.Apps[intItem].Visible;
  if not appList.ShowAll then appList.EndUpdate;
end;

procedure TfrmMenu.pmnuitmPafDataMoveBottomClick(Sender: TObject);
begin
  appList.SortBottom(pmnuPafData.Tag);
end;

procedure TfrmMenu.pmnuitmPafDataMoveDownClick(Sender: TObject);
begin
  appList.SortDown(pmnuPafData.Tag);
end;

procedure TfrmMenu.pmnuitmPafDataMoveTopClick(Sender: TObject);
begin
  appList.SortTop(pmnuPafData.Tag);
end;

procedure TfrmMenu.pmnuitmPafDataMoveUpClick(Sender: TObject);
begin
  appList.SortUp(pmnuPafData.Tag);
end;

procedure TfrmMenu.pmnuitmPafDataMoveUsingKeyboardClick(Sender: TObject);
begin
  dlgMoveItem.Execute(AppList, pmnuPafData.Tag);
end;

// =====================================

procedure TfrmMenu.pmnuitmPafDataRemovefromMenuClick(Sender: TObject);
var
  intItem: Integer;
begin
  if bolIsLive then
    exit;
  intItem := pmnuPafData.Tag;
  DeleteFile(appList.Apps[intItem].GetPAFFile);
  appList.BeginUpdate;
  appList.Delete(intItem);
  appList.EndUpdate;
end;

procedure TfrmMenu.pmnuitmPafDataRenameAppClick(Sender: TObject);
// Edit the paf-data file to rename the app
var
  intItem: Integer;
  strAppName: String;
  strCaption: String;
  strPrompt: String;
begin
  if bolIsLive then
    exit;
  intItem := pmnuPafData.Tag;
  if appList.Apps[intItem].IsMenu then
  begin
    strCaption := strRenameCategory;
    strPrompt := strCategoryName + '  (' + appList.Apps[intItem].Name + ')';
  end else begin
    strCaption := strRenameApp;
    strPrompt := strAppRenameMessage;
  end;
  strAppName:=InputBox(strCaption, strPrompt, appList.Apps[intItem].Caption);
  if strAppName<>appList.Apps[intItem].Caption then
  begin
    appList.BeginUpdate;
    appList.Apps[intItem].Caption := strAppName;
    appList.EndUpdate;
  end;
end;

// =====================================

procedure TfrmMenu.pmnuitmOptionsShowHideMenuClick(Sender: TObject);
// Show/Hide the menu, regardless of bolVisible setting
var
  bolOriginalVisible: Boolean;
begin
  // Backup bolVisible and disable it
  bolOriginalVisible:=bolVisible;
  bolVisible:=False;
  // Hide if visible, else fade in
  if frmMenu.Visible then
    FadeInOut(false)
  else
    FadeInOut(true);
  // Restore bolVisible
  bolVisible:=bolOriginalVisible;
end;

// =====================================

procedure TfrmMenu.pmnuitmOptionsSmallFontsClick(Sender: TObject);
// Switch to small fonts
begin
  pmnuitmOptionsSmallFonts.Checked:=true;
  ChangeMenuFontSize(8);
end;

procedure TfrmMenu.pmnuitmOptionsSnapToScreenClick(Sender: TObject);
begin
  pmnuitmOptionsSnapToScreen.Checked := not pmnuitmOptionsSnapToScreen.Checked;
  frmMenu.ScreenSnap := pmnuitmOptionsSnapToScreen.Checked;
end;

procedure TfrmMenu.pmnuitmOptionsSortAlphaCategoriesFirstClick(Sender: TObject);
begin
  AppList.ReSort(astAlphaCtgFirst);
end;

procedure TfrmMenu.pmnuitmOptionsSortAlphaCategoriesLastClick(Sender: TObject);
begin
  AppList.ReSort(astAlphaCtgLast);
end;

procedure TfrmMenu.pmnuitmOptionsSortAlphaSortClick(Sender: TObject);
begin
  AppList.ReSort(astAlpha);
end;

// =====================================

procedure TfrmMenu.pmnuitmOptionsLargeFontsClick(Sender: TObject);
// Switch to large fonts
begin
  pmnuitmOptionsLargeFonts.Checked:=true;
  ChangeMenuFontSize(10);
end;

procedure TfrmMenu.pmnuitmOptionsLoadFromDBClick(Sender: TObject);
begin
  if not pmnuitmOptionsLoadFromDB.Checked then
  begin
    bolLoadAppsFromDB:=True;
    pmnuitmOptionsLoadFromDB.Checked:=True;
  end
  else
  begin
    bolLoadAppsFromDB:=False;
    pmnuitmOptionsLoadFromDB.Checked:=False;
  end;
  if bolLoadAppsFromDB then
  begin
    AppList.Modified := True;
    // Force Modified this time
  end else begin
    if FileExists(AppList.AppDBName) then
      DeleteFile(AppList.AppDBName);
    if FileExists(ChangeFileExt(AppList.AppDBName, '.fsi')) then
      DeleteFile(ChangeFileExt(AppList.AppDBName, '.fsi'));
  end;
end;

// =====================================

procedure TfrmMenu.pmnuitmOptionsLoadWallpaperClick(Sender: TObject);
// Enable or disable the wallpaper swapper
begin
  // Set bolLoadWallpaper
  if not pmnuitmOptionsLoadWallpaper.Checked then
  begin
    bolLoadWallpaper := True;
    pmnuitmOptionsLoadWallpaper.Checked := True;
  end
  else
  begin
    bolLoadWallpaper := False;
    pmnuitmOptionsLoadWallpaper.Checked := False;
  end;

  // Reload wallpaper
  if bolLoadWallpaper then
  begin
    pmnuitmOptionsLoadWallpaper.Enabled := True;
    // If we have a wallpaper specifically set for this theme, use it, else use the global one
    if FileExists(ExtractFileDir(ParamStr(0))+'\Data\'+strTheme+'Wallpaper.bmp') then
      SetWallPaper(ExtractFileDir(ParamStr(0))+'\Data\'+strTheme+'Wallpaper.bmp', '2', '0')
    else if FileExists(ExtractFileDir(ParamStr(0))+'\Data\myWallpaper.bmp') then
      SetWallPaper(ExtractFileDir(ParamStr(0))+'\Data\myWallpaper.bmp', '2', '0')
    // For compatability with the original wallpaper-swapper, look in DefaultData too
    else if FileExists(ExtractFileDir(ParamStr(0))+'\App\DefaultData\Wallpaper\myWallpaper.bmp') then
      SetWallPaper(ExtractFileDir(ParamStr(0))+'\App\DefaultData\Wallpaper\myWallpaper.bmp', '2', '0')
    else
    begin
      SetWallPaper(strOriginalWallpaper, strOriginalWallpaperStyle, strOriginalWallpaperTiled);
    end;
  end
  else
    SetWallPaper(strOriginalWallpaper, strOriginalWallpaperStyle, strOriginalWallpaperTiled);
end;

// =====================================

procedure TfrmMenu.pmnuitmOptionsAddAppClick(Sender: TObject);
// Add an app
var
  strPortableAppsPath: string;
  procInstaller: TProcessInformation;
  startInstaller: TStartupInfo;
begin
  strAppToInstall:='';
  frmAddApp.lblAdd.Caption:=strInstallMessage;
  frmAddApp.btnInstall.Caption:=strAppInstallButtonOK;
  frmAddApp.btnCancel.Caption:=strAppInstallButtonCancel;
  frmAddApp.ShowModal;
  if strAppToInstall<>'' then
  begin
    if RightStr(strAppToInstall, 8)<>'.pat.exe' then
      strPortableAppsPath := ExtractFileDir(ExtractFileDir(ParamStr(0)))+'\'
    else
      strPortableAppsPath := ExtractFileDir(ParamStr(0))+'\Data\Theme\';

    FillChar(procInstaller, sizeof(TProcessInformation), 0);
    FillChar(startInstaller, sizeof(TStartupInfo), 0);
    startInstaller.cb := sizeof(TStartupInfo);

    if CreateProcess(nil, PAnsiChar('"' + strAppToInstall + '" -o"' + strPortableAppsPath + '" -y -/SILENT=YES /DESTINATION="' + strPortableAppsPath+'"'+#0), nil,
      nil, false, NORMAL_PRIORITY_CLASS, nil, nil,
      startInstaller, procInstaller) <> False then
    begin
      WaitForSingleObject(procInstaller.hProcess, INFINITE);
      CloseHandle(procInstaller.hThread);
      CloseHandle(procInstaller.hProcess);
    end
    else
      ShowMessageFmt(strAppInstallFailed, [strAppToInstall]);

    SetupButtons();
    DisplayButtons();
  end;
end;

procedure TfrmMenu.pmnuitmOptionsAddExternalAppClick(Sender: TObject);
begin
  if bolIsLive then
    Exit;
  opndlgExternalApp.InitialDir := Copy(Application.ExeName,0,3);
  opndlgExternalApp.Title := strExternalAppPrompt;
  if opndlgExternalApp.Execute then
  begin
    if not AnsiSameText(ExtractFileDrive(opndlgExternalApp.FileName), ExtractFileDrive(Application.ExeName)) then
    begin
      ShowMessage(strExternalAppDriveError);
      Exit;
    end;
    appList.AddExternalApp(opndlgExternalApp.FileName);
  end;
end;

// =====================================

procedure TfrmMenu.pmnuitmOptionsDisableDraggingClick(Sender: TObject);
begin
  pmnuitmOptionsDisableDragging.Checked := not pmnuitmOptionsDisableDragging.Checked;
end;

procedure TfrmMenu.pmnuitmOptionsDisableFadeClick(Sender: TObject);
// Disable fade effect
begin
  if not TMenuItem(Sender).Checked then
  begin
    bolDisableFade:=True;
    TMenuItem(Sender).Checked:=True;
  end
  else
  begin
    bolDisableFade:=False;
    TMenuItem(Sender).Checked:=False;
  end;
end;

// =====================================

procedure TfrmMenu.pmnuitmOptionsRemoveAppClick(Sender: TObject);
// Remove an app - placeholder for actual procedure
begin
  ShowMessage(strAppRemoveMessage);
  ShellExecute(0,'open', PAnsiChar(ExtractFileDir(ExtractFileDir(ParamStr(0))) + '\' +#0), Nil, Nil, SW_SHOW);
end;

// =====================================
procedure TfrmMenu.pmnuitmOptionsRestorePositionClick(Sender: TObject);
// Restore Default Position (And Show Menu) (XrXca)
begin
  frmMenu.ScreenSnap := False;
  intOffsetX := intDefaultOffsetX;
  intOffsetY := intDefaultOffsetY;
  if bolSwitchSide then
  begin
    Left:=0+intOffsetX;
    Top:=0+intOffsetY;
  end
  else
  begin
    Left:= Screen.WorkAreaRect.Right-Width+intOffsetX;
    Top:= Screen.WorkAreaRect.Bottom-Height+intOffsetY;
  end;
  if not frmMenu.Visible then
    FadeInOut(true);
  frmMenu.ScreenSnap := pmnuitmOptionsSnapToScreen.Checked;
end;

// =====================================

procedure TfrmMenu.pmnuitmOptionsRefreshAppsClick(Sender: TObject);
// Refresh apps list
begin
    SetupButtons();
    DisplayButtons();
end;

// =====================================

procedure TfrmMenu.pmnuitmOptionsGetMoreClick(Sender: TObject);
// Get more applications
begin
  ShellExecute(0,'open', PAnsiChar(ExtractFileDir(ExtractFileDir(ParamStr(0))) + '\FirefoxPortable\FirefoxPortable.exe'), 'http://portableapps.com/apps', Nil, SW_SHOWNORMAL);
end;

// =====================================

procedure TfrmMenu.pmnuitmSearchDriveClick(Sender: TObject);
// Open windows search for this drive
begin
  ShellExecute(0,'find', PAnsiChar(ExtractFileDrive(ParamStr(0)) + '\' +#0), Nil, Nil, SW_SHOW);
end;

// =====================================

procedure TfrmMenu.pmnuitmSearchComputerClick(Sender: TObject);
// Open windows search for the drive containing the WINDIR
var
  strWinDir: string;
begin
  strWinDir := GetEnvironmentVariable('WINDIR');
  ShellExecute(0,'find', PAnsiChar(ExtractFileDrive(strWinDir) + '\' +#0), Nil, Nil, SW_SHOW);
end;

// =====================================

procedure TfrmMenu.pmnuitmSearchWebClick(Sender: TObject);
// Open a web search in Firefox Portable
begin
  ShellExecute(0,'open', PAnsiChar(ExtractFileDir(ExtractFileDir(ParamStr(0))) + '\FirefoxPortable\FirefoxPortable.exe'), 'http://start.portableapps.com/', Nil, SW_SHOWNORMAL);
end;

// =====================================

procedure TfrmMenu.ChangeMenuFontSize(intFontSize: integer);
// Change the font size of the menu components
var
  intCounter: integer;
begin
  for intCounter := 0 to Length(AppList.ButtonsArray) - 1 do
    AppList.ButtonsArray[intCounter].font.size:=intFontSize;
  appList.SetFontSize(intFontSize);
  sbtnDocuments.font.size:=intFontSize;
  sbtnMusic.font.size:=intFontSize;
  sbtnPictures.font.size:=intFontSize;
  sbtnVideo.font.size:=intFontSize;
  sbtnExplore.font.size:=intFontSize;
  sbtnBackup.font.size:=intFontSize;
  sbtnOptions.font.size:=intFontSize;
  sbtnHelp.font.size:=intFontSize;
  sbtnSearch.font.size:=intFontSize;
  for intCounter := 0 to Length(sbtnarrCustomButtons) - 1 do
    sbtnarrCustomButtons[intCounter].Font.Size := intFontSize;
end;

// =====================================

procedure TfrmMenu.InitButtons(intListLength: Integer);
// Initialize the button array.
var
  intStart: Integer;
  intCounter: Integer;
begin
  // map our app buttons on the form to the array
  intStart := Length(AppList.ButtonsArray);

  // Apply theme button offsets
  AppList.ButtonsArray[0].Left:=15+intAppOffsetX;
  AppList.ButtonsArray[0].Top:=82+intAppOffsetY;

  if intStart > intListLength then
  begin
    for intCounter := intStart - 1 downto intListLength do
      AppList.ButtonsArray[intCounter].Free; // Clear Unused Buttons
    SetLength(AppList.ButtonsArray, intListLength);
  end else begin
    SetLength(AppList.ButtonsArray, intListLength);
    // Increase the size of the array
    for intCounter := intStart to intListLength - 1 do
    begin
      // Create new button
      AppList.ButtonsArray[intCounter]:=TSpeedButton.Create(self);
      // Copy properties
      with AppList.ButtonsArray[intCounter] do
      begin
        // Initialize
        Parent := frmMenu;
        Name := 'dynsbtnApplication'+IntToStr(intCounter+1);
        Caption := AppList.ButtonsArray[intCounter].Name;

        // Copy Visual options
        Hint := AppList.ButtonsArray[0].Hint;
        ParentShowHint := AppList.ButtonsArray[0].ParentShowHint;
        ShowHint := AppList.ButtonsArray[0].ShowHint;
        Height := AppList.ButtonsArray[0].Height;
        Width := AppList.ButtonsArray[0].Width;
        Glyph := AppList.ButtonsArray[0].Glyph;
        Font := AppList.ButtonsArray[0].Font;
        ParentFont := AppList.ButtonsArray[0].ParentFont;
        Margins := AppList.ButtonsArray[0].Margins;
        Margin := AppList.ButtonsArray[0].Margin;
        Flat := AppList.ButtonsArray[0].Flat;
        Transparent := AppList.ButtonsArray[0].Transparent;
        Visible := True;
        PopupMenu := AppList.ButtonsArray[0].PopupMenu;

        // Copy Events
        OnClick := AppList.ButtonsArray[0].OnClick;
        OnMouseDown := AppList.ButtonsArray[0].OnMouseDown;
        OnMouseUp := AppList.ButtonsArray[0].OnMouseUp;

      end;
    end;
  end;
  if intListLength > 1 then
    for intCounter := 1 to intListLength - 1 do
      with AppList.ButtonsArray[intCounter] do
      begin
        Top := AppList.ButtonsArray[0].Top+22*intCounter;
        Left := AppList.ButtonsArray[0].Left;
      end;
  if not bolSeperateAppArrows then
    sbtnScrollDown.Top := AppList.ButtonsArray[intListLength-1].Top + 23;
end;

// =====================================

procedure TFrmMenu.SetupButtonsFromDB();
// Set up the icon list from a pre-built database
begin
  appList.Clear;
  appList.BeginUpdate;
  if ( not appList.LoadFromDB ) or ( appList.Count = 0 ) then
  begin // Load from path if DB load fails
    appList.EndUpdate;
    SetupButtons;
    Exit;
  end;
  AppList.ButtonsArray[0].Tag := appList.FirstVisible;
  appList.EndUpdate;
  ScrollApps(True); // Force the scrollbuttons to be correct;
end;

// =====================================

procedure TFrmMenu.SetupButtons();
var
  slExclude: TStringList;
//  stLastType: TAppSortType;
begin
  // Filter out the parent, current, PortableAppsMenu and PortableAppsBackup directories
  slExclude := TStringList.Create;
  slExclude.Add('.');
  slExclude.Add('..');
  slExclude.Add('PortableAppsMenu');
  slExclude.Add('PortableAppsBackup');
  appList.Clear;
  appList.BeginUpdate;
  appList.LoadCategories;
  appList.LoadFromPath(ExtractFileDir(ExtractFileDir(ParamStr(0))), slExclude);
  AppList.ButtonsArray[0].Tag := appList.FirstVisible;
  slExclude.Free;
  appList.ReSort;
  appList.EndUpdate;
  ScrollApps(True); // Force the scrollbuttons to be correct;
end;

// =====================================

procedure TfrmMenu.DisplayButtons();
// Draw the icons onto the menu buttons
begin
  appList.DrawButtons;
  // If we have more applications that app icon positions, enable scrolling
  if appList.AtTop then
    sbtnScrollUp.Visible:=False
  else
    sbtnScrollUp.Visible:=True;
  if appList.AtBottom then
    sbtnScrollDown.Visible:=False
  else
    sbtnScrollDown.Visible:=True;

  // Set customizable button captions
  sbtnDocuments.Caption:=GetStoredVariable('sbtnDocuments_NAME', sbtnDocuments.Caption);
  sbtnMusic.Caption:=GetStoredVariable('sbtnMusic_NAME', sbtnMusic.Caption);
  sbtnPictures.Caption:=GetStoredVariable('sbtnPictures_NAME', sbtnPictures.Caption);
  sbtnVideo.Caption:=GetStoredVariable('sbtnVideo_NAME', sbtnVideo.Caption);

  // Brind the scroll buttons to the front of the Z-order
  sbtnScrollUp.BringToFront;
  sbtnScrollDown.BringToFront;

  // Set the X offsets for the scroll-up and scroll-down buttons
  if not BolSeperateAppArrows then
  begin
    sbtnScrollUp.Left := 15+intAppOffsetX;;
    sbtnScrollDown.Left := 15+intAppOffsetX;;
  end;
end;

// =====================================

procedure TfrmMenu.SetupMenus();
// Set up the Locale & Theme menus
// Acknowledgement: http://delphi.about.com/od/kbcurt/a/dynamicmenuitem.htm for the handy tutorial
var
  pmnuitmTemp: TMenuItemExtended;
  tsrchDirectory: TSearchRec;
  slThemes: TStringList;
  bolDefaultFound: boolean;
begin
  // Clear the menus
  pmnuitmOptionsLocale.Clear;
  pmnuitmOptionsTheme.Clear;
  // Set up locale menu
  if FindFirst(ExtractFileDir(ParamStr(0)) + '\Data\Locale\*.locale',faAnyFile,tsrchDirectory)=0 then
  begin
    repeat
      pmnuitmTemp:=TMenuItemExtended.Create(pmnuitmOptionsLocale);
      pmnuitmTemp.Value:=ExtractFileDir(ParamStr(0)) + '\Data\Locale\' + tsrchDirectory.FindData.cFileName;
      pmnuitmTemp.Caption:=LeftStr(ExtractFileName(pmnuitmTemp.Value), Length(ExtractFileName(pmnuitmTemp.Value))-7);
      pmnuitmTemp.OnClick:=pmnuitmLocaleClick;
      pmnuitmTemp.RadioItem:=True;
      // If it's the currently enabled locale, enable it's menu option
      if AnsiLowerCase(tsrchDirectory.FindData.cFileName)=AnsiLowerCase(strLocale) then
        pmnuitmTemp.Checked:=true;
      pmnuitmOptionsLocale.Add(pmnuitmTemp);
    Until FindNext(tsrchDirectory)<>0;
    FindClose(tsrchDirectory);
  end
  else
  begin
    // Insert dummy item to make it look like a submenu
    pmnuitmTemp:=TMenuItemExtended.Create(pmnuitmOptionsLocale);
    pmnuitmOptionsLocale.Add(pmnuitmTemp);
    pmnuitmOptionsLocale.Enabled:=False;
  end;
  // Set up theme menu
  bolDefaultFound := False;
  slThemes := TStringList.Create;
  slThemes.Sorted := True;
  if FindFirst(ExtractFileDir(ParamStr(0)) + '\Data\Theme\*',faDirectory,tsrchDirectory)=0 then
  begin
    repeat
      // Make sure it's a directory and filter out the '.' and '..' directories
      If ((tsrchDirectory.Attr And faDirectory)<>0) And (tsrchDirectory.Name<>'.') And (tsrchDirectory.Name<>'..') Then
      if AnsiLowerCase(tsrchDirectory.FindData.cFileName) = 'default' then
        bolDefaultFound := True
      else
        slThemes.Add(tsrchDirectory.FindData.cFileName);
    Until FindNext(tsrchDirectory)<>0;
    FindClose(tsrchDirectory);
  end;
  if bolDefaultFound then
  begin
    slThemes.Sorted := False;
    slThemes.Insert(0, 'Default');
    while slThemes.Count > 0 do
    begin
      pmnuitmTemp:=TMenuItemExtended.Create(pmnuitmOptionsTheme);
      pmnuitmTemp.Value:=slThemes[0];
      pmnuitmTemp.Caption:=ExtractFileName(pmnuitmTemp.Value);
      pmnuitmTemp.OnClick:=pmnuitmThemeClick;
      pmnuitmTemp.RadioItem:=True;
      // If it's the currently enabled theme, enable it's menu option
      if AnsiLowerCase(pmnuitmTemp.Value)=AnsiLowerCase(strTheme) then
        pmnuitmTemp.Checked:=true;
      pmnuitmOptionsTheme.Add(pmnuitmTemp);
      slThemes.Delete(0);
    end;
    slThemes.Free;
  end
  else
  begin
    // No Themes, not even default
    ShowMessage(strDefaultThemeCorrupted);
    bolIsLive:=True; // Make sure we don't edit the ini file by mistake
    Application.Terminate;
    exit;
  end;
end;

// =====================================

procedure TfrmMenu.pmnuitmLocaleClick(Sender : TObject);
// Click handler for the locale menu
begin
  //Get the locale name from the menu caption
  strLocale:=RightStr(TMenuItemExtended(Sender).Caption+'.locale', Length(TMenuItemExtended(Sender).Caption+'.locale')-1);
  LoadLocale();
  // Redisplay any custom buttons
  DisplayButtons;
  lblDriveSpace.Caption:= strDriveFree + ' ' + strFreeOf + ' ' + strDriveSize;
end;

// =====================================

procedure TfrmMenu.pmnuitmThemeClick(Sender : TObject);
// Theme menu click handler
begin
  // Set strTheme from the Value option
  strTheme:=TMenuItemExtended(Sender).Value;
  LoadTheme();
end;

// =====================================

procedure TfrmMenu.pmnuOptionsPopup(Sender: TObject);
// Unhide the TrayIcon-exclusive buttons if tag is not equal to 1
begin
  if TPopupMenu(Sender).Tag = 1 then
  begin
    pmnuitmOptionsDivider4.Visible :=( intOffsetX <> intDefaultOffsetX ) or ( intOffsetY <> intDefaultOffsetY );
    pmnuitmOptionsRestorePosition.Visible := ( intOffsetX <> intDefaultOffsetX ) or ( intOffsetY <> intDefaultOffsetY );
    pmnuitmOptionsShowHideMenu.Visible:=False;
    pmnuitmOptionsExit.Visible:=False;
  end
  else
  begin
    pmnuitmOptionsDivider4.Visible:=True;
    pmnuitmOptionsRestorePosition.Visible := ( intOffsetX <> intDefaultOffsetX ) or ( intOffsetY <> intDefaultOffsetY );
    pmnuitmOptionsShowHideMenu.Visible:=True;
    pmnuitmOptionsExit.Visible:=True;
  end;
  // hide / display snap to scren option depending on status of dragging option
  pmnuitmOptionsSnapToScreen.Visible := not pmnuitmOptionsDisableDragging.Checked;
  pmnuitmOptionsSortAlphaSort.Checked := ( appList.LastSort = astAlpha );
  pmnuitmOptionsSortAlphaCategoriesFirst.Checked := ( appList.LastSort = astAlphaCtgFirst );
  pmnuitmOptionsSortAlphaCategoriesLast.Checked := ( appList.LastSort = astAlphaCtgLast );

end;

procedure TfrmMenu.pmnuPafDataPopup(Sender: TObject);
begin
  if appList.Apps[TControl(Sender).Tag].PAFWriteable then
  begin
    pmnuitmPafDataHideApp.Visible := True;
    pmnuitmPafDataRenameApp.Visible := True;
    pmnuitmPafDataAutoRunApp.Visible := True;
    pmnuitmPafDataExecOnClose.Visible := True;
    pmnuitmPafDataCategory.Visible := True;
    appList.CategoryMenu(TControl(Sender).Tag, pmnuitmPafDataCategory);
  end else begin
    pmnuitmPafDataHideApp.Visible := False;
    pmnuitmPafDataRenameApp.Visible := False;
    pmnuitmPafDataAutoRunApp.Visible := False;
    pmnuitmPafDataExecOnClose.Visible := False;
    pmnuitmPafDataCategory.Visible := False;
  end;
  pmnuitmPafDataMoveTop.Enabled := AppList.CanSortUp(TControl(Sender).Tag);
  pmnuitmPafDataMoveUp.Enabled := pmnuitmPafDataMoveTop.Enabled;
  pmnuitmPafDataMoveDown.Enabled := AppList.CanSortDown(TControl(Sender).Tag);
  pmnuitmPafDataMoveBottom.Enabled := pmnuitmPafDataMoveDown.Enabled;

  pmnuitmPafDataAutoRunApp.Checked := appList.Apps[TControl(Sender).Tag].AutoExec;
  pmnuitmPafDataHideApp.Checked := not appList.Apps[TControl(Sender).Tag].Visible;
  pmnuitmPafdataExecOnClose.Checked := appList.Apps[TControl(Sender).Tag].ExecOnClose;

  if appList.Apps[TControl(Sender).Tag].IsMenu then
  begin
    pmnuitmPafDataAutoRunApp.Visible := False;
    pmnuitmPafDataExecOnClose.Visible := False;
    pmnuitmPafDataDeleteCategory.Visible := True;
    pmnuitmPafDataEditCategory.Visible := True;
    pmnuitmPafDataExploreHere.Visible := False;
    pmnuitmPafDataHideApp.Caption := strHideCategory;
    pmnuitmPafDataRenameApp.Caption := strRenameCategory;
  end else begin
    pmnuitmPafDataRemovefromMenu.Visible := appList.Apps[TControl(Sender).Tag].ExternalApp;
    pmnuitmPafDataExploreHere.Visible := True;
    pmnuitmPafDataDeleteCategory.Visible := False;
    pmnuitmPafDataEditCategory.Visible := False;
    pmnuitmPafDataHideApp.Caption := strHideApp;
    pmnuitmPafDataRenameApp.Caption := strRenameApp;
  end;
end;

// =====================================

function TfrmMenu.RunExe(strExe: string): boolean;
// Execute an EXE from within its own directory if flag is set
var
  strDir: string;
  useDir: boolean;
begin
  strDir := ExtractFilePath(strExe);
  useDir := DirectoryExists(strDir);
  if useDir then
  begin
    Result := (ShellExecute(0,'open', PAnsiChar(strExe),Nil, PAnsiChar(strDir), SW_SHOW) > 32);
  end
  else
  begin
    Result := (ShellExecute(0,'open', PAnsiChar(strExe),Nil, Nil, SW_SHOW) > 32);
  end;
end;

// =====================================

function TfrmMenu.GetStoredVariable(strVariable: String; strDefault: String) : String;
// Get a variable stored in the configuration ini
var
  iniSettings: TINIFile;
  strIniLocation : String;
begin
  strIniLocation:=LeftStr(ExtractFileDir(ParamStr(0)) + '\' + ExtractFileName(ParamStr(0)),length(ExtractFileDir(ParamStr(0)) + '\' + ExtractFileName(ParamStr(0)))-4) + '.ini';
  if FileExists(strIniLocation) then begin
    iniSettings:=TINIFile.Create(strIniLocation);
    result:=iniSettings.ReadString('SETTINGS', strVariable, strDefault);
    iniSettings.Free;
  end
  else
    result:=strDefault;
end;

// =====================================

procedure TfrmMenu.SetStoredVariable(strVariable: String; strSetting: String);
// Insert a variable into the configuration ini
var
  iniSettings: TINIFile;
  strIniLocation : String;
begin
  strIniLocation:=LeftStr(ExtractFileDir(ParamStr(0)) + '\' + ExtractFileName(ParamStr(0)),length(ExtractFileDir(ParamStr(0)) + '\' + ExtractFileName(ParamStr(0)))-4) + '.ini';
  iniSettings:=TINIFile.Create(strIniLocation);
  iniSettings.WriteString('SETTINGS', strVariable, strSetting);
  iniSettings.UpdateFile();
  iniSettings.Free();
end;

// =====================================

function TfrmMenu.GetStoredSection(strSection: String) : TStringList;
// Get an enire section of settings
var
  iniSettings: TINIFile;
  strIniLocation : String;
  lstResult: TStringList;
begin
  strIniLocation:=ChangeFileExt(ParamStr(0), '.ini');
  iniSettings:=TINIFile.Create(strIniLocation);
  lstResult:=TStringList.Create;
  inisettings.ReadSectionValues(strSection, lstResult);
  result:=lstResult;
  iniSettings.Free;
end;

// =====================================

procedure TfrmMenu.SetStoredSection(strSection: String; tstrlstContents: TStringList);
// Insert a TStringList into the config file
var
  iniSettings: TINIFile;
  intCounter: Integer;
  strIniLocation : String;
begin
  strIniLocation:=ChangeFileExt(ParamStr(0), '.ini');
  iniSettings:=TINIFile.Create(strIniLocation);
  iniSettings.EraseSection(strSection);
  for intCounter := 0 to tstrlstContents.Count - 1 do
  begin
    iniSettings.WriteString(strSection,
      tstrlstContents.Names[intCounter],
      tstrlstContents.ValueFromIndex[intCounter]
    );
  end;
  iniSettings.Free;
end;

// =====================================

function TfrmMenu.GetWallpaper() : String;
// Get the path to the current wallpaper
var
  regWallpaper: TRegistry;
begin
  result:='';
  regWallpaper:=TRegistry.Create;
  try
  if regWallpaper.OpenKey('\Control Panel\desktop', False) then
  begin
      result:=regWallpaper.ReadString('Wallpaper');
  end;
  finally
    regWallpaper.Free;
  end;
end;

// =====================================

function TfrmMenu.GetWallpaperStyle() : String;
// Get the Wallpaper Style (EG tiled, stretched, etc)
var
  regWallpaper: TRegistry;
begin
  result:='';
  regWallpaper:=TRegistry.Create;
  try
  if regWallpaper.OpenKey('\Control Panel\desktop', False) then
  begin
      result:=regWallpaper.ReadString('WallpaperStyle');
  end;
  finally
    regWallpaper.Free;
  end;
end;

// =====================================

function TfrmMenu.GetTileWallpaper() : String;
// Get the Tile Wallpaper setting
var
  regWallpaper: TRegistry;
begin
  result:='';
  regWallpaper:=TRegistry.Create;
  try
  if regWallpaper.OpenKey('\Control Panel\desktop', False) then
  begin
      result:=regWallpaper.ReadString('TileWallpaper');
  end;
  finally
    regWallpaper.Free;
  end;
end;

// =====================================

procedure TfrmMenu.SetWallpaper(strFilename, strWallpaperStyle, strTileWallpaper: String);
// Set a new wallpaper
var
  regWallpaper: TRegistry;
begin
  regWallpaper:=TRegistry.Create;
  try
  if regWallpaper.OpenKey('\Control Panel\desktop', False) then
  begin
    regWallpaper.WriteString('Wallpaper', strFilename);
    regWallpaper.WriteString('WallpaperStyle', strWallpaperStyle);
    regWallpaper.WriteString('TileWallpaper', strTileWallpaper);
    SystemParametersInfo (SPI_SETDESKWALLPAPER,0, nil,SPIF_SENDWININICHANGE) ;
  end;
  finally
    regWallpaper.Free;
  end;
end;

// =====================================

procedure TfrmMenu.LoadLocale();
// Load locale file
begin
  with TINIFile.Create(ExtractFileDir(ParamStr(0))+'\Data\Locale\'+strLocale) do
  begin
    strLocaleVersion := ReadString('LOCALE', 'VERSION', ' out of date or unavaliable');
    strFreeOf :=
                    ReadString('FORM_MAIN', 'DRIVE_SPACE_FREE', 'free of');
    sbtnDocuments.Caption :=
                    ReadString('FORM_MAIN', 'ICON_DOCUMENTS', 'Documents');
    sbtnMusic.Caption :=
                    ReadString('FORM_MAIN', 'ICON_MUSIC', 'Music');
    sbtnPictures.Caption :=
                    ReadString('FORM_MAIN', 'ICON_PICTURES', 'Pictures');
    sbtnVideo.Caption :=
                    ReadString('FORM_MAIN', 'ICON_VIDEOS', 'Video');
    sbtnExplore.Caption :=
                    ReadString('FORM_MAIN', 'ICON_EXPLORE', 'Explore');
    sbtnBackup.Caption :=
                    ReadString('FORM_MAIN', 'ICON_BACKUP', 'Backup');
    sbtnOptions.Caption :=
                    ReadString('FORM_MAIN', 'ICON_OPTIONS', 'Options');
    sbtnHelp.Caption :=
                    ReadString('FORM_MAIN', 'ICON_HELP', 'Help');
    sbtnSearch.Caption :=
                    ReadString('FORM_MAIN', 'ICON_SEARCH', 'Search');
    pmnuitmOptionsSmallFonts.Caption :=
                    ReadString('FORM_MAIN', 'MENU_OPTIONS_SMALL_FONTS', 'Small Fonts');
    pmnuitmOptionsLargeFonts.Caption :=
                    ReadString('FORM_MAIN', 'MENU_OPTIONS_LARGE_FONTS', 'Large Fonts');
    pmnuitmOptionsLocale.Caption :=
                    ReadString('FORM_MAIN', 'MENU_OPTIONS_LOCALE', 'Language');
    pmnuitmOptionsTheme.Caption :=
                    ReadString('FORM_MAIN', 'MENU_OPTIONS_THEME', 'Theme');
    pmnuitmOptionsUnhideApps.Caption :=
                    ReadString('FORM_MAIN', 'MENU_OPTIONS_UNHIDE_APPS', 'Unhide Apps');
    pmnuitmOptionsSortApps.Caption :=
                    ReadString('FORM_MAIN', 'MENU_OPTIONS_SORT_APPS', 'Sort Apps');
    pmnuitmOptionsSortAlphaSort.Caption :=
                    ReadString('FORM_MAIN', 'MENU_OPTIONS_SORT_ALPHA', 'Alpha Sort');
    pmnuitmOptionsSortAlphaCategoriesFirst.Caption :=
                    ReadString('FORM_MAIN', 'MENU_OPTIONS_SORT_CTG_FIRST', 'Alpha, Categories First');
    pmnuitmOptionsSortAlphaCategoriesLast.Caption :=
                    ReadString('FORM_MAIN', 'MENU_OPTIONS_SORT_CTG_LAST', 'Alpha, Categories Last');
    pmnuitmOptionsAddApp.Caption :=
                    ReadString('FORM_MAIN', 'MENU_OPTIONS_ADD_APP', 'Install a New App');
    pmnuitmOptionsRemoveApp.Caption :=
                    ReadString('FORM_MAIN', 'MENU_OPTIONS_REMOVE_APP', 'Remove an App');
    pmnuitmOptionsAddExternalApp.Caption :=
                    ReadString('FORM_MAIN', 'MENU_OPTIONS_ADD_EXTERNAL_APP', 'Add an External App');
    pmnuitmOptionsRefreshApps.Caption :=
                    ReadString('FORM_MAIN', 'MENU_OPTIONS_REFRESH_ICONS', 'Refresh App Icons');
    pmnuitmOptionsGetMore.Caption :=
                    ReadString('FORM_MAIN', 'MENU_OPTIONS_GET_APPS', 'Get More Apps...');
    pmnuitmOptionsStayVisible.Caption :=
                    ReadString('FORM_MAIN', 'MENU_OPTIONS_STAY_VISIBLE', 'Stay Visible');
    pmnuitmOptionsDisableDragging.Caption :=
                    ReadString('FORM_MAIN', 'MENU_OPTIONS_DISABLE_DRAGGING', 'Disable Dragging');
    pmnuitmOptionsSnapToScreen.Caption :=
                    ReadString('FORM_MAIN', 'MENU_OPTIONS_SNAP_TO_SCREEN', 'Snap to Screen');
    pmnuitmOptionsDisableFade.Caption :=
                    ReadString('FORM_MAIN', 'MENU_OPTIONS_DISABLE_FADE', 'Disable Fade Effect');
    pmnuitmOptionsLoadFromDB.Caption :=
                    ReadString('FORM_MAIN', 'MENU_OPTIONS_LOAD_APPS_FROM_DB', 'Load Apps from DB');
    pmnuitmOptionsLoadWallpaper.Caption  :=
                    ReadString('FORM_MAIN', 'MENU_OPTIONS_ENABLE_WALLPAPER_SWAP', 'Enable Wallpaper Swap');
    pmnuitmOptionsRestorePosition.Caption :=
                    ReadString('FORM_MAIN', 'MENU_OPTIONS_RESTORE_POSITION', 'Restore Position');
    pmnuitmOptionsShowHideMenu.Caption :=
                    ReadString('FORM_MAIN', 'MENU_OPTIONS_SHOW_HIDE_MENU', 'Show/Hide Menu');
    pmnuitmOptionsExit.Caption :=
                    ReadString('FORM_MAIN', 'MENU_OPTIONS_EXIT', 'Exit');
    pmnuitmPafDataHideApp.Caption :=
                    ReadString('FORM_MAIN', 'MENU_PAFDATA_HIDE_APP', 'Hide App');
    strHideApp := pmnuitmPafDataHideApp.Caption;
    strHideCategory  :=
                    ReadString('FORM_MAIN', 'MENU_PAFDATA_HIDE_CATEGORY', 'Hide Category');
    pmnuitmPafDataRenameApp.Caption :=
                    ReadString('FORM_MAIN', 'MENU_PAFDATA_RENAME_APP', 'Rename App');
    strRenameApp := pmnuitmPafDataRenameApp.Caption;
    strRenameCategory :=
                    ReadString('FORM_MAIN', 'MENU_PAFDATA_RENAME_CATEGORY', 'Rename Category');
    pmnuitmPafDataExecOnClose.Caption :=
                    ReadString('FORM_MAIN', 'MENU_PAFDATA_EXEC_ON_CLOSE', 'Exec on Close');
    pmnuitmPafDataExploreHere.Caption :=
                    ReadString('FORM_MAIN', 'MENU_PAFDATA_EXPLORE', 'Explore Here...');
    strAppRenameMessage :=
                    ReadString('FORM_MAIN', 'MENU_PAFDATA_RENAME_MESSAGE', 'Enter the application''s new name');
    pmnuitmPafDataRemovefromMenu.Caption :=
                    ReadString('FORM_MAIN', 'MENU_PAFDATA_REMOVE_EXTERNAL', 'Remove From Menu');
    pmnuitmPafDataAutoRunApp.Caption :=
                    ReadString('FORM_MAIN', 'MENU_PAFDATA_AUTOEXEC_APP', 'Autorun App');
    pmnuitmBackup.Caption :=
                    ReadString('FORM_MAIN', 'MENU_BACKUP', 'Backup Files');
    pmnuitmRestore.Caption :=
                    ReadString('FORM_MAIN', 'MENU_RESTORE', 'Restore From Backup');
    pmnuitmSearchDrive.Caption :=
                    ReadString('FORM_MAIN', 'MENU_SEARCH_DRIVE', 'Search This Drive');
    pmnuitmSearchComputer.Caption :=
                    ReadString('FORM_MAIN', 'MENU_SEARCH_COMPUTER', 'Search This Computer');
    pmnuitmSearchWeb.Caption :=
                    ReadString('FORM_MAIN', 'MENU_SEARCH_WEB', 'Search The Web');
    pmnuitmCustButtonsRename.Caption :=
                    ReadString('FORM_MAIN', 'MENU_CUSTBUTTONS_RENAME', 'Rename Button');
    strRenameButtonCaption :=
                    ReadString('FORM_MAIN', 'MENU_CUSTBUTTONS_RENAME_CAPTION', 'Rename Button');
    strRenameButtonPrompt :=
                    ReadString('FORM_MAIN', 'MENU_CUSTBUTTONS_RENAME_PROMPT', 'Please enter the new name for this customizable button');
    pmnuitmCustButtonsChange.Caption :=
                    ReadString('FORM_MAIN', 'MENU_CUSTBUTTONS_CHANGE', 'Change Button Path');
    strChangeButtonCaption :=
                    ReadString('FORM_MAIN', 'MENU_CUSTBUTTONS_CHANGE_CAPTION', 'Change Button Path');
    strChangeButtonPrompt :=
                    ReadString('FORM_MAIN', 'MENU_CUSTBUTTONS_CHANGE_PROMPT', 'Please enter the path to the directory you wish to assign to this button (excluding the drive letter)');
    strAppRemoveMessage :=
                    ReadString('FORM_MAIN', 'MENU_OPTIONS_REMOVE_APP_MESSAGE', 'To remove an application, delete it''s directory in the PortableApps folder and restart the Portable Apps Menu. When you press OK, the PortableApps folder will be loaded.');
    strNewCategory :=
                    ReadString('FORM_MAIN', 'MENU_PAFDATA_CATEGORY_NEW', 'New Category');
    pmnuitmPafDataCategory.Caption :=
                    ReadString('FORM_MAIN', 'MENU_PAFDATA_CATEGORY', 'Category');
    pmnuitmPafDataAddCategory.Caption :=
                    ReadString('FORM_MAIN', 'MENU_PAFDATA_CATEGORY_ADD', 'Add Category');
    pmnuitmPafDataDeleteCategory.Caption :=
                    ReadString('FORM_MAIN', 'MENU_PAFDATA_CATEGORY_DELETE', 'Delete Category');
    pmnuitmPafDataEditCategory.Caption :=
                    ReadString('FORM_MAIN', 'MENU_PAFDATA_CATEGORY_EDIT', 'Edit Category');
    pmnuitmPafDataMove.Caption :=
                    ReadString('FORM_MAIN', 'MENU_PAFDATA_MOVE', 'Move');
    pmnuitmPafDataMoveTop.Caption :=
                    ReadString('FORM_MAIN', 'MENU_PAFDATA_MOVE_TOP', 'Top');
    pmnuitmPafDataMoveUp.Caption :=
                    ReadString('FORM_MAIN', 'MENU_PAFDATA_MOVE_UP', 'Up');
    pmnuitmPafDataMoveDown.Caption :=
                    ReadString('FORM_MAIN', 'MENU_PAFDATA_MOVE_DOWN', 'Down');
    pmnuitmPafDataMoveBottom.Caption :=
                    ReadString('FORM_MAIN', 'MENU_PAFDATA_MOVE_BOTTOM', 'Bottom');
    pmnuitmPafDataMoveUsingKeyboard.Caption :=
                    ReadString('FORM_MAIN', 'MENU_PAFDATA_MOVE_KEYBOARD', 'Using Keyboard');
    strExternalAppPrompt  :=
                    ReadString('FORM_MAIN', 'EXTERNAL_PROMPT', 'Select Application to Add to Menu');

    strDefaultThemeCorrupted :=
                    ReadString('ERRORS', 'DEFAULT_THEME_CORRUPTED', 'The default theme is either corrupted or not installed correctly and the program cannot continue. Please reinstall the application to correct this problem.');
    strSelectedThemeCorrupted :=
                    ReadString('ERRORS', 'SELECTED_THEME_CORRUPTED', 'The theme you last selected, ''%s'', is not installed correctly, has been deleted or is corrupted. You are now being automatically reverted to the default theme.');
    strHelpDialog :=
                    ReadString('ERRORS', 'HELP_UNSUPPORTED', 'PortableApps Menu MOD (version %s, locale %s) is a modification of the PortableApps Menu and is not supported by PortableApps.com. For more information, visit the PortableApps.com forum and search for PortableAppsMenu MOD.');
    strTranslator :=
                    ReadString('ERRORS', 'HELP_TRANSLATOR', 'PortableApps Menu MOD (version %s, locale %s) is a modification of the PortableApps Menu and is not supported by PortableApps.com. For more information, visit the PortableApps.com forum and search for PortableAppsMenu MOD.');
    strRegisterHotkeyError :=
                    ReadString('ERRORS', 'REGISTER_HOTKEY_ERROR', 'Global Hotkey could not be registered. This is likely because another program is using the Shift-Win or Shift-F11 hotkey.');
    strExternalAppDriveError :=
                    ReadString('ERRORS', 'EXTERNAL_DRIVE_ERROR', 'Any applications added must be on the same drive as the menu');
    strInstallMessage :=
                    ReadString('FORM_INSTALL', 'INSTALL_MESSAGE', 'Applications in PortableApps Format can be installed automatically by the PortableApps Menu.'+' After you''ve downloaded the app you''d like to install -- the files end in .paf.exe -- just click the install button below and select the file.  PortableApps Menu will take care of the rest.');
    strAppInstallFailed :=
                    ReadString('FORM_INSTALL', 'INSTALL_FAILED', 'Could not execute %s');
    strAppInstallButtonOK :=
                    ReadString('FORM_INSTALL', 'INSTALL_BUTTON_INSTALL', 'Install');
    strAppInstallButtonCancel :=
                    ReadString('FORM_INSTALL', 'INSTALL_BUTTON_CANCEL', 'Cancel');

    strCategoryName :=
                    ReadString('FORM_CATEGORY', 'CATEGORY_NAME', 'Category Name');
    strCategoryTitle :=
                    ReadString('FORM_CATEGORY', 'CATEGORY_TITLE', 'Edit Category');
    strCategoryHint :=
                    ReadString('FORM_CATEGORY', 'CATEGORY_HINT', 'Category Hint');
    strCategoryButtonSave :=
                    ReadString('FORM_CATEGORY', 'CATEGORY_BUTTON_SAVE', 'Save');
    strCategoryButtonCancel :=
                    ReadString('FORM_CATEGORY', 'CATEGORY_BUTTON_CANCEL', 'Cancel');
    strOpenChangeCaption :=
                    ReadString('FORM_CATEGORY', 'CATEGORY_CHANGE_OPEN_ICON', 'Change &Open Icon');
    strOpenResetCaption :=
                    ReadString('FORM_CATEGORY', 'CATEGORY_RESET_OPEN_ICON', 'Reset &Open Icon');
    strClosedChangeCaption :=
                    ReadString('FORM_CATEGORY', 'CATEGORY_CHANGE_CLOSED_ICON', 'Change Closed Icon');
    strClosedResetCaption :=
                    ReadString('FORM_CATEGORY', 'CATEGORY_RESET_OPEN_ICON', 'Reset &Closed Icon');
    strCategoryDriveError :=
                    ReadString('FORM_CATEGORY', 'CATEGORY_DRIVE_ERROR', 'The icon file must be on the same drive as the menu');

    strMoveDlgCancel :=
                    ReadString('FORM_MOVE', 'MOVE_BUTTON_CANCEL', 'Cancel');
    strMoveDialogText :=
                    ReadString('FORM_MOVE', 'MOVE_LABEL_TEXT', 'Use Up and Down Arrows or Scroll Wheel to Move the Item, Esc to Cancel');

    Free;
  end;

  // Reload our menus
  SetupMenus;
end;

// =====================================

function TfrmMenu.ThemeShadow: Boolean;
// Get the shadow on off option from theme, will only be applied at program startup
begin
  Result := True;
  strTheme:=GetStoredVariable('Theme', 'default');
  if FileExists(ExtractFileDir(ParamStr(0)) + '/Data/Theme/'+strTheme+'/Theme.ini') then
  with TIniFile.Create(ExtractFileDir(ParamStr(0)) + '/Data/Theme/'+strTheme+'/Theme.ini') do
  begin
    Result := StrToBoolDef(ReadString('frmMenu', 'Shadow', 'true'), True);
    Free;
  end;
end;

// =====================================

procedure TfrmMenu.LoadTheme();
// Load theme data
var
  jpgTempImage: TJPEGImage;
  bmpTempImage: TBitmap;
  iniTheme: TIniFile;
  defTheme: TIniFile;
  strSection: String;
  strBorderType: String;
  strlstCustomImages: TStringList;
  intCounter: Integer;
  mtdOnClickMethod: TMethod;
  strMenuIcon: String;
  strOpenIcon: String;

  procedure LoadThemeVisible(strSectionName: String; ctrlControl: TControl);
  begin
    ctrlControl.Visible:=iniTheme.ReadBool(strSectionName, 'Visible', defTheme.ReadBool(strSectionName, 'Visible', True));
  end;

  procedure LoadThemePosition(strSectionName: String; ctrlControl: TControl);
  begin
    with ctrlControl do
    begin
      Height:=iniTheme.ReadInteger(strSectionName, 'Height', defTheme.ReadInteger(strSectionName, 'Height', Height));
      Width:=iniTheme.ReadInteger(strSectionName, 'Width', defTheme.ReadInteger(strSectionName, 'Width', Width));
      Left:=iniTheme.ReadInteger(strSectionName, 'Left', defTheme.ReadInteger(strSectionName, 'Left', Left));
      Top:=iniTheme.ReadInteger(strSectionName, 'Top', defTheme.ReadInteger(strSectionName, 'Top', Top));
    end;
  end;

  procedure LoadThemePositionVisible(strSectionName: String; ctrlControl: TControl);
  begin
    LoadThemePosition(strSectionName, ctrlControl);
    LoadThemeVisible(strSectionName, ctrlControl);
  end;

  procedure LoadThemeFont(strSectionName: String; fntFont: TFont);
  var
    strFontKey: String;
  begin
    with fntFont do
    begin
      Name:=iniTheme.ReadString(strSectionName, 'Font', defTheme.ReadString(strSectionName, 'Font', Name));
      // Really bad hack, some elements use fontcolor and some use color
      // This should be fixed in thems, all should use FontColor
      if ( iniTheme.ReadInteger(strSectionName, 'FontColorR', -1) <> -1 ) then
        strFontKey := 'Font'
      else if ( iniTheme.ReadInteger(strSectionName, 'ColorR', -1) <> -1 ) then
        strFontKey := ''
      else if ( defTheme.ReadInteger(strSectionName, 'FontColorR', -1) <> -1 ) then
        strFontKey := 'Font'
      else
        strFontKey := '';
      Color:=RGB(
        iniTheme.ReadInteger(strSectionName, strFontKey + 'ColorR', defTheme.ReadInteger(strSectionName, strFontKey + 'ColorR', GetRValue(Color))),
        iniTheme.ReadInteger(strSectionName, strFontKey + 'ColorG', defTheme.ReadInteger(strSectionName, strFontKey + 'ColorG', GetGValue(Color))),
        iniTheme.ReadInteger(strSectionName, strFontKey + 'ColorB', defTheme.ReadInteger(strSectionName, strFontKey + 'ColorB', GetBValue(Color)))
      );
      Style:=[];
      if iniTheme.ReadBool(strSectionName, 'Bold', defTheme.ReadBool(strSectionName, 'Bold', True)) then
        Style:=Style + [fsBold];
      if iniTheme.ReadBool(strSectionName, 'Italic', defTheme.ReadBool(strSectionName, 'Italic', False)) then
        Style:=Style + [fsItalic];
      if iniTheme.ReadBool(strSectionName, 'Underline', defTheme.ReadBool(strSectionName, 'Underline', False)) then
        Style:=Style + [fsUnderline];
      if iniTheme.ReadBool(strSectionName, 'StrikeOut', defTheme.ReadBool(strSectionName, 'StrikeOut', False)) then
        Style:=Style + [fsStrikeOut];
    end;
  end;

  procedure LoadThemeButton(strSectionName: String; sbtnButton: TSpeedButton);
  begin
    with sbtnButton do
    begin
      Margin:=iniTheme.ReadInteger(strSectionName, 'Margin', defTheme.ReadInteger(strSectionName, 'Margin', 33));
      LoadThemePositionVisible(strSectionName, sbtnButton);
      LoadThemeFont(strSectionName, sbtnButton.Font);
    end;
  end;

begin
  // Refresh the menus
  SetupMenus;

  // Put App Object in Update mode
  appList.BeginUpdate;

  if FileExists(ExtractFileDir(ParamStr(0)) + '/Data/Theme/'+strTheme+'/Theme/background.jpg')<>True then
  begin
    if (AnsiLowerCase(strTheme)='default') then
      begin
        ShowMessage(strDefaultThemeCorrupted);
        bolIsLive:=True; // Make sure we don't edit the ini file by mistake
        Application.Terminate;
        exit;
      end
      else
      begin
        ShowMessageFmt(strSelectedThemeCorrupted, [strTheme]);
        strTheme:='default';
        // Check that the default theme exists
        if FileExists(ExtractFileDir(ParamStr(0)) + '/Data/Theme/'+strTheme+'/Theme/background.jpg')<>True then
        begin
          ShowMessage(strDefaultThemeCorrupted);
          bolIsLive:=True; // Make sure we don't edit the ini file by mistake
          Application.Terminate;
          exit;
        end;
      end;
  end;

  // Check that the icontheme exists
  strIconTheme:=strTheme;
  if FileExists(ExtractFileDir(ParamStr(0)) + '/Data/Theme/'+strIconTheme+'/IconTheme/backup.ico')<>True then
  begin
    //If it doesn't, load the default icontheme
    strIconTheme:='default';
    if FileExists(ExtractFileDir(ParamStr(0)) + '/Data/Theme/'+strIconTheme+'/IconTheme/backup.ico')<>True then
    begin
      ShowMessage(strDefaultThemeCorrupted);
      bolIsLive:=True; // Make sure we don't edit the ini file by mistake
      Application.Terminate;
      exit;
    end;
  end;

  // Set Folder Icons
  if FileExists(ExtractFileDir(ParamStr(0)) + '\Data\Theme\'+strTheme+'\IconTheme\folder.ico') then
  begin
    strMenuIcon := ExtractFileDir(ParamStr(0)) + '\Data\Theme\'+strTheme+'\IconTheme\folder.ico';
    if FileExists(ExtractFileDir(ParamStr(0)) + '\Data\Theme\'+strTheme+'\IconTheme\folderopen.ico') then
    begin
      strOpenIcon := ExtractFileDir(ParamStr(0)) + '\Data\Theme\'+strTheme+'\IconTheme\folderopen.ico';
    end else begin
      strOpenIcon := '';
    end;
  end else if FileExists(ExtractFileDir(ParamStr(0)) + '\Data\Theme\Default\IconTheme\folder.ico') then
  begin
    strMenuIcon := ExtractFileDir(ParamStr(0)) + '\Data\Theme\Default\IconTheme\folder.ico';
    if FileExists(ExtractFileDir(ParamStr(0)) + '\Data\Theme\Default\IconTheme\folderopen.ico') then
    begin
      strOpenIcon := ExtractFileDir(ParamStr(0)) + '\Data\Theme\Default\IconTheme\folderopen.ico';
    end else begin
      strOpenIcon := '';
    end;
  end else
  begin
    strMenuIcon := ParamStr(0);
    strOpenIcon := '';
  end;
  appList.DefaultIconPath := strMenuIcon;
  appList.DefaultOpenIconPath := strOpenIcon;

  // Load Theme
  jpgTempImage := TJPEGImage.Create;
  jpgTempImage.LoadFromFile(ExtractFileDir(ParamStr(0)) + '/Data/Theme/'+strTheme+'/Theme/background.jpg');
  imgBackground.Canvas.Draw(0,0,jpgTempImage);
  jpgTempImage.Free;
  bmpTempImage := TBitmap.Create;
  bmpTempImage.LoadFromFile(ExtractFileDir(ParamStr(0)) + '/Data/Theme/'+strTheme+'/Theme/background_top.bmp');
  imgBackground.Canvas.Draw(0,0,bmpTempImage);
  bmpTempImage.Free;
  imgDriveSpace.Picture.LoadFromFile(ExtractFileDir(ParamStr(0)) + '/Data/Theme/'+strTheme+'/Theme/drive_space_slider.bmp');

  // Load Icons
  imgBackup.Picture.Icon.LoadFromFile(ExtractFileDir(ParamStr(0)) + '/Data/Theme/'+strIconTheme+'/IconTheme/backup.ico');
  imgDocuments.Picture.Icon.LoadFromFile(ExtractFileDir(ParamStr(0)) + '/Data/Theme/'+strIconTheme+'/IconTheme/documents.ico');
  imgExplore.Picture.Icon.LoadFromFile(ExtractFileDir(ParamStr(0)) + '/Data/Theme/'+strIconTheme+'/IconTheme/explore.ico');
  imgHelp.Picture.Icon.LoadFromFile(ExtractFileDir(ParamStr(0)) + '/Data/Theme/'+strIconTheme+'/IconTheme/help.ico');
  imgMusic.Picture.Icon.LoadFromFile(ExtractFileDir(ParamStr(0)) + '/Data/Theme/'+strIconTheme+'/IconTheme/music.ico');
  imgOptions.Picture.Icon.LoadFromFile(ExtractFileDir(ParamStr(0)) + '/Data/Theme/'+strIconTheme+'/IconTheme/options.ico');
  imgPictures.Picture.Icon.LoadFromFile(ExtractFileDir(ParamStr(0)) + '/Data/Theme/'+strIconTheme+'/IconTheme/pictures.ico');
  imgSearch.Picture.Icon.LoadFromFile(ExtractFileDir(ParamStr(0)) + '/Data/Theme/'+strIconTheme+'/IconTheme/search.ico');
  imgVideo.Picture.Icon.LoadFromFile(ExtractFileDir(ParamStr(0)) + '/Data/Theme/'+strIconTheme+'/IconTheme/video.ico');

  // If a Theme.INI file exists, use it to recolor the text/reposition the buttons
  // Otherwise, use the default theme's theme.ini
  // WARNING: Massive block of code ahead
  if FileExists(ExtractFileDir(ParamStr(0)) + '/Data/Theme/'+strTheme+'/theme.ini') then
  begin
    {$ifdef RedirectThemeINI}
    iniTheme:=TINIRedirect.Create(ExtractFileDir(ParamStr(0)) + '/Data/Theme/'+strTheme+'/theme.ini');
    {$else}
    iniTheme:=TINIFile.Create(ExtractFileDir(ParamStr(0)) + '/Data/Theme/'+strTheme+'/theme.ini');
    {$endif}
  end
  else
  begin
    // Check for default theme
    if FileExists(ExtractFileDir(ParamStr(0)) + '/Data/Theme/Default/IconTheme/backup.ico')<>True then
    begin
      ShowMessage(strDefaultThemeCorrupted);
      bolIsLive:=True; // Make sure we don't edit the ini file by mistake
      Application.Terminate;
      exit;
    end;

    {$ifdef RedirectThemeINI}
    iniTheme:=TINIRedirect.Create(ExtractFileDir(ParamStr(0)) + '/Data/Theme/Default/theme.ini');
    {$else}
    iniTheme:=TINIFile.Create(ExtractFileDir(ParamStr(0)) + '/Data/Theme/Default/theme.ini');
    {$endif}
  end;
    {$ifdef RedirectThemeINI}
    defTheme:=TINIRedirect.Create(ExtractFileDir(ParamStr(0)) + '/Data/Theme/Default/theme.ini');
    {$else}
    defTheme:=TINIFile.Create(ExtractFileDir(ParamStr(0)) + '/Data/Theme/Default/theme.ini');
    {$endif}

    // Main Form
    begin
      frmMenu.Height:=iniTheme.ReadInteger('frmMenu', 'Height', defTheme.ReadInteger('frmMenu', 'Height', frmMenu.Height));
      frmMenu.Width:=iniTheme.ReadInteger('frmMenu', 'Width', defTheme.ReadInteger('frmMenu', 'Width', frmMenu.Width));
      // Set border type
      strBorderType:=ansiLowerCase(iniTheme.ReadString('frmMenu', 'BorderStyle', iniTheme.ReadString('frmMenu', 'BorderStyle', 'bsnone')));
      if strBorderType = 'bsnone' then
        frmMenu.BorderStyle:=bsNone
      else if strBorderType = 'bsdialog' then
       frmMenu.BorderStyle:=bsDialog
      else if strBorderType = 'bssingle' then
       frmMenu.BorderStyle:=bsSingle
      else if strBorderType = 'bssizeable' then
       frmMenu.BorderStyle:=bsSizeable
      else if strBorderType = 'bssizeoolwin' then
       frmMenu.BorderStyle:=bsSizeToolWin
      else if strBorderType = 'bstoolwindow' then
       frmMenu.BorderStyle:=bsToolWindow;

      // Set form color
      frmMenu.Color:=RGB(
        iniTheme.ReadInteger('frmMenu', 'ColorR', defTheme.ReadInteger('frmMenu', 'ColorR', GetRValue(frmMenu.Color))),
        iniTheme.ReadInteger('frmMenu', 'ColorG', defTheme.ReadInteger('frmMenu', 'ColorG', GetGValue(frmMenu.Color))),
        iniTheme.ReadInteger('frmMenu', 'ColorB', defTheme.ReadInteger('frmMenu', 'ColorB', GetBValue(frmMenu.Color)))
        );
      // Side/offset settings
      bolSwitchSide:=iniTheme.ReadBool('frmMenu', 'SwitchSides', False);
      intDefaultOffsetX:=OffsetToInt(iniTheme.ReadString('frmMenu', 'OffsetX', defTheme.ReadString('frmMenu', 'OffsetX', '-4')), Screen.WorkAreaRect.Right);
      intDefaultOffsetY:=OffsetToInt(iniTheme.ReadString('frmMenu', 'OffsetY', defTheme.ReadString('frmMenu', 'OffsetY', '-4')), Screen.WorkAreaRect.Bottom);
      ApplyThemeOffsets; // Thought I'd need it in more places, (XrXca)
    end;

    // imgDriveSpace   (Exception to normal loads, no width set)
    strSection:='imgDriveSpace';
    begin
      imgDriveSpace.Height:=iniTheme.ReadInteger(strSection, 'Height', defTheme.ReadInteger(strSection, 'Height', imgDriveSpace.Height));
      imgDriveSpace.Left:=iniTheme.ReadInteger(strSection, 'Left', defTheme.ReadInteger(strSection, 'Left', imgDriveSpace.Left));
      imgDriveSpace.Top:=iniTheme.ReadInteger(strSection, 'Top', defTheme.ReadInteger(strSection, 'Top', imgDriveSpace.Top));
      imgDriveSpace.Visible:=iniTheme.ReadBool(strSection, 'Visible', defTheme.ReadBool(strSection, 'Visible', imgDriveSpace.Visible));
      imgDriveSpace.Stretch:=iniTheme.ReadBool(strSection, 'Stretch', defTheme.ReadBool(strSection, 'Stretch', imgDriveSpace.Stretch));
    end;

    // imgBackground
    LoadThemePositionVisible('imgBackground', imgBackground);

    // Logo Images
    LoadThemePosition('imgPortableAppsLogo1', imgPortableAppsLogo1);
    LoadThemePosition('imgPortableAppsLogo2', imgPortableAppsLogo2);
    LoadThemePosition('imgPortableAppsLogo3', imgPortableAppsLogo3);
    LoadThemePosition('imgPortableAppsLogo4', imgPortableAppsLogo4);
    LoadThemePosition('imgPortableAppsLogo5', imgPortableAppsLogo5);
    LoadThemePosition('imgPortableAppsLogo6', imgPortableAppsLogo6);
    LoadThemePosition('imgPortableAppsLogoPixel', imgPortableAppsLogoPixel);

    // Button Images
    LoadThemePositionVisible('imgDocuments', imgDocuments);
    LoadThemePositionVisible('imgMusic', imgMusic);
    LoadThemePositionVisible('imgPictures', imgPictures);
    LoadThemePositionVisible('imgVideo', imgVideo);
    LoadThemePositionVisible('imgExplore', imgExplore);
    LoadThemePositionVisible('imgBackup', imgBackup);
    LoadThemePositionVisible('imgOptions', imgOptions);
    LoadThemePositionVisible('imgHelp', imgHelp);
    LoadThemePositionVisible('imgSearch', imgSearch);
    // Buttons
    LoadThemeButton('sbtnDocuments', sbtnDocuments);
    LoadThemeButton('sbtnMusic', sbtnMusic);
    LoadThemeButton('sbtnPictures', sbtnPictures);
    LoadThemeButton('sbtnVideo', sbtnVideo);
    LoadThemeButton('sbtnExplore', sbtnExplore);
    LoadThemeButton('sbtnBackup', sbtnBackup);
    LoadThemeButton('sbtnOptions', sbtnOptions);
    LoadThemeButton('sbtnHelp', sbtnHelp);
    LoadThemeButton('sbtnSearch', sbtnSearch);

    // Dividers
    LoadThemePositionVisible('imgDivider1', imgDivider1);
    LoadThemePositionVisible('imgDivider2', imgDivider2);

    // imgClose
    LoadThemePositionVisible('imgClose', imgClose);

    // lblDriveName
    LoadThemePositionVisible('lblDriveName', lblDriveName);
    LoadThemeFont('lblDriveName', lblDriveName.Font);
    // lblDriveSpace
    LoadThemePositionVisible('lblDriveSpace', lblDriveSpace);
    LoadThemeFont('lblDriveSpace', lblDriveSpace.Font);

    // AppButtons
    strSection:='AppButtons';
    begin
      LoadThemeFont(strSection, appList.AppFont);
      appList.TransColor:=RGB(
        iniTheme.ReadInteger(strSection, 'TransparentColorR', defTheme.ReadInteger(strSection, 'TransparentColorR', GetRValue(sbtnApplication1.Glyph.TransparentColor))),
        iniTheme.ReadInteger(strSection, 'TransparentColorG', defTheme.ReadInteger(strSection, 'TransparentColorG', GetGValue(sbtnApplication1.Glyph.TransparentColor))),
        iniTheme.ReadInteger(strSection, 'TransparentColorB', defTheme.ReadInteger(strSection, 'TransparentColorB', GetBValue(sbtnApplication1.Glyph.TransparentColor)))
      );
      intAppOffsetX:=iniTheme.ReadInteger(strSection, 'OffsetX', defTheme.ReadInteger(strSection, 'OffsetX', 0));
      intAppOffsetY:=iniTheme.ReadInteger(strSection, 'OffsetY', defTheme.ReadInteger(strSection, 'OffsetY', 0));
      InitButtons(iniTheme.ReadInteger(strSection, 'ListSize', defTheme.ReadInteger(strSection, 'ListSize', 20)));
      // Set the seperate app arrows preference, if true use their individual offset/size controls
      bolSeperateAppArrows:=iniTheme.ReadBool(strSection, 'SeperateAppArrows', defTheme.ReadBool(strSection, 'SeperateAppArrows', False));
    end;

    // Menu Subitem Offset
    appList.MenuIndent := iniTheme.ReadInteger('MenuButtons', 'SubItemOffset', defTheme.ReadInteger('MenuButtons', 'SubItemOffset', appList.MenuIndent));
    // Menu Item Fonts
    LoadThemeFont('MenuButtons', appList.MenuFont);
    LoadThemeFont('OpenMenuButtons', appList.MenuOpenFont);

    // Scroll Buttons
    LoadThemePosition('sbtnScrollUp', sbtnScrollUp);
    LoadThemePosition('sbtnScrollDown', sbtnScrollDown);

    // Destroy the old images
    for intCounter := 0 to Length(imgarrCustomImages) - 1 do
      imgarrCustomImages[intCounter].Free;

    // Initialize our list of custom images
    strlstCustomImages:=TStringList.Create;
    // Load our custom image elements
    iniTheme.ReadSection('CustomImages', strlstCustomImages);
    SetLength(imgarrCustomImages, strlstCustomImages.Count);
    for intCounter := 0 to strlstCustomImages.Count - 1 do
    begin
      // Create a new image and set the strSection parameter
      imgarrCustomImages[intCounter] := TImage.Create(self);
      strSection := iniTheme.ReadString('CustomImages', strlstCustomImages.Strings[intCounter], '');
      with imgarrCustomImages[intCounter] do
      begin
        // Initialization stuff
        Parent := frmMenu;
        Name := 'dynimgCustomImage'+IntToStr(intCounter);
        // Visual settings
        LoadThemePosition(strSection, imgarrCustomImages[intCounter]);
        Transparent := True;
        Stretch := True;
        // Picture (if it doesn't exist, throw an error and load the default theme)
        if FileExists(ExtractFileDir(ParamStr(0))+'/Data/Theme/'+strTheme+'/'+iniTheme.ReadString(strSection, 'Path', '')) then
          Picture.LoadFromFile(ExtractFileDir(ParamStr(0))+'/Data/Theme/'+strTheme+'/'+iniTheme.ReadString(strSection, 'Path', ''))
        else
        begin
          ShowMessageFmt(strSelectedThemeCorrupted, [strTheme]);
          strTheme:='Default';
          LoadTheme;
          exit;
        end;
        // OnClick handler - Assign a method with our onclick handler
        mtdOnClickMethod.Data := frmMenu;
        mtdOnClickMethod.Code := frmMenu.MethodAddress(iniTheme.ReadString(strSection, 'OnClick', ''));
        // If it was assigned, typecast it to a procedure and set OnClick to it
        if Assigned(mtdOnClickMethod.Code) then
        begin
          OnClick := TNotifyEvent(mtdOnClickMethod);
          Hint := StringReplace(StringReplace(StringReplace(iniTheme.ReadString(strSection, 'PathToApp', ''),
            '{DRIVE}', ExtractFileDrive(ParamStr(0)), [rfReplaceAll, rfIgnoreCase]),
            '{APP}', ExtractFileDir(ExtractFileDir(ParamStr(0))), [rfReplaceAll, rfIgnoreCase]),
            '{THEME}', ExtractFileDir(ParamStr(0))+'/Data/Theme/'+strTheme, [rfReplaceAll, rfIgnoreCase]);
        end
        else
        begin
          // Otherwise, look for a pathtoapp variable, parse it (thanks xrxca!) and assign the generic onclick handler
          Hint := StringReplace(StringReplace(StringReplace(iniTheme.ReadString(strSection, 'PathToApp', ''),
            '{DRIVE}', ExtractFileDrive(ParamStr(0)), [rfReplaceAll, rfIgnoreCase]),
            '{APP}', ExtractFileDir(ExtractFileDir(ParamStr(0))), [rfReplaceAll, rfIgnoreCase]),
            '{THEME}', ExtractFileDir(ParamStr(0))+'/Data/Theme/'+strTheme, [rfReplaceAll, rfIgnoreCase]);
          OnClick := dynimgCustomImageClick;
        end;
      end;
    end;
    strlstCustomImages.Free;

    // Destroy old custom buttons
    for intCounter := 0 to Length(sbtnarrCustomButtons) - 1 do
      sbtnarrCustomButtons[intCounter].Free;
    // Initialize our list of custom buttons
    strlstCustomImages:=TStringList.Create;
    // Load our custom button elements
    iniTheme.ReadSection('CustomButtons', strlstCustomImages);
    SetLength(sbtnarrCustomButtons, strlstCustomImages.Count);
    for intCounter := 0 to strlstCustomImages.Count - 1 do
    begin
      // Create a new image and set the strSection parameter
      sbtnarrCustomButtons[intCounter] := TSpeedButton.Create(self);
      strSection := iniTheme.ReadString('CustomButtons', strlstCustomImages.Strings[intCounter], '');
      with sbtnarrCustomButtons[intCounter] do
      begin
        // Initialization stuff
        Parent := frmMenu;
        Name := 'dynimgCustomButton'+IntToStr(intCounter);
        Flat := True;
        ParentFont := False;
        Transparent := sbtnHelp.Transparent;
        Font.Size := sbtnHelp.Font.Size;

        // Visual settings
        LoadThemeButton(strSection, sbtnarrCustomButtons[intCounter]);
        Caption := iniTheme.ReadString(strSection, 'Caption', strSection);

        // OnClick handler - Assign a method with our onclick handler
        mtdOnClickMethod.Data := frmMenu;
        mtdOnClickMethod.Code := frmMenu.MethodAddress(iniTheme.ReadString(strSection, 'OnClick', ''));
        // If it was assigned, typecast it to a procedure and set OnClick to it
        if Assigned(mtdOnClickMethod.Code) then
        begin
          OnClick := TNotifyEvent(mtdOnClickMethod);
          Hint := StringReplace(StringReplace(StringReplace(iniTheme.ReadString(strSection, 'PathToApp', ''),
            '{DRIVE}', ExtractFileDrive(ParamStr(0)), [rfReplaceAll, rfIgnoreCase]),
            '{APP}', ExtractFileDir(ExtractFileDir(ParamStr(0))), [rfReplaceAll, rfIgnoreCase]),
            '{THEME}', ExtractFileDir(ParamStr(0))+'/Data/Theme/'+strTheme, [rfReplaceAll, rfIgnoreCase]);
        end
        else
        begin
          // Otherwise, look for a pathtoapp variable, parse it (thanks xrxca!) and assign the generic onclick handler
          Hint := StringReplace(StringReplace(StringReplace(iniTheme.ReadString(strSection, 'PathToApp', ''),
            '{DRIVE}', ExtractFileDrive(ParamStr(0)), [rfReplaceAll, rfIgnoreCase]),
            '{APP}', ExtractFileDir(ExtractFileDir(ParamStr(0))), [rfReplaceAll, rfIgnoreCase]),
            '{THEME}', ExtractFileDir(ParamStr(0))+'/Data/Theme/'+strTheme, [rfReplaceAll, rfIgnoreCase]);
          OnClick := dynimgCustomImageClick;
        end;
        BringToFront;
      end;
    end;
    strlstCustomImages.Free;

    // Set '[imgPortableAppsLogoDebug]' settings
    strSection:='imgPortableAppsLogoDebug';
    bolForcePixel:=iniTheme.ReadBool(strSection, 'ForcePixel', defTheme.ReadBool(strSection, 'ForcePixel', False));
    bolForceAlpha:=iniTheme.ReadBool(strSection, 'ForceAlpha', defTheme.ReadBool(strSection, 'ForceAlpha', False));

    // Load Header.bmp into imgPortableAppsLogoPixel and force display (if it exists)
    // NOTE: Located here instead of the initial image code because it overrides bolForcePixel.
    if FileExists(ExtractFileDir(ParamStr(0)) + '/Data/Theme/'+strTheme+'/Theme/header.bmp') then
    begin
      imgPortableAppsLogoPixel.Picture.LoadFromFile(ExtractFileDir(ParamStr(0)) + '/Data/Theme/'+strTheme+'/Theme/header.bmp');
      bolForceAlpha:=False;
      bolForcePixel:=True;
    end
    else
      imgPortableAppsLogoPixel.Picture:=picOriginalLogo;

  // Show alpha logo for XP and pixel transparent logo for others
  if (Win32MajorVersion >= 5) and (Win32MinorVersion >= 1)
        AND (Win32Platform = VER_PLATFORM_WIN32_NT) then
  begin
    imgPortableAppsLogoPixel.Visible := false;
    imgPortableAppsLogo1.Visible := true;
    imgPortableAppsLogo2.Visible := true;
    imgPortableAppsLogo3.Visible := true;
    imgPortableAppsLogo4.Visible := true;
    imgPortableAppsLogo5.Visible := true;
    imgPortableAppsLogo6.Visible := true;
  end
  else begin
    imgPortableAppsLogoPixel.Visible := true;
    imgPortableAppsLogo1.Visible := false;
    imgPortableAppsLogo2.Visible := false;
    imgPortableAppsLogo3.Visible := false;
    imgPortableAppsLogo4.Visible := false;
    imgPortableAppsLogo5.Visible := false;
    imgPortableAppsLogo6.Visible := false;
  end;

  // Force a logo to display if a themer has set ForcePixel or ForceAlpha to true
  if bolForcePixel then
  begin
    imgPortableAppsLogoPixel.Visible := true;
    imgPortableAppsLogo1.Visible := false;
    imgPortableAppsLogo2.Visible := false;
    imgPortableAppsLogo3.Visible := false;
    imgPortableAppsLogo4.Visible := false;
    imgPortableAppsLogo5.Visible := false;
    imgPortableAppsLogo6.Visible := false;
  end;
  if bolForceAlpha then
  begin
    imgPortableAppsLogoPixel.Visible := false;
    imgPortableAppsLogo1.Visible := true;
    imgPortableAppsLogo2.Visible := true;
    imgPortableAppsLogo3.Visible := true;
    imgPortableAppsLogo4.Visible := true;
    imgPortableAppsLogo5.Visible := true;
    imgPortableAppsLogo6.Visible := true;
  end;

  // Close our INI files
  defTheme.Free();
  iniTheme.Free();

  // Update the button locations
  DisplayButtons();

  // Reload wallpaper
  if bolLoadWallpaper then
  begin
    pmnuitmOptionsLoadWallpaper.Enabled := True;
    // If we have a wallpaper specifically set for this theme, use it, else use the global one
    if FileExists(ExtractFileDir(ParamStr(0))+'\Data\'+strTheme+'Wallpaper.bmp') then
      SetWallPaper(ExtractFileDir(ParamStr(0))+'\Data\'+strTheme+'Wallpaper.bmp', '2', '0')
    else if FileExists(ExtractFileDir(ParamStr(0))+'\Data\myWallpaper.bmp') then
      SetWallPaper(ExtractFileDir(ParamStr(0))+'\Data\myWallpaper.bmp', '2', '0')
    // For compatability with the original wallpaper-swapper, look in DefaultData too
    else if FileExists(ExtractFileDir(ParamStr(0))+'\App\DefaultData\Wallpaper\myWallpaper.bmp') then
      SetWallPaper(ExtractFileDir(ParamStr(0))+'\App\DefaultData\Wallpaper\myWallpaper.bmp', '2', '0')
    else
    begin
      SetWallPaper(strOriginalWallpaper, strOriginalWallpaperStyle, strOriginalWallpaperTiled);
    end;
  end;
  // End App Object Update mode (redraw)
  appList.EndUpdate;
  // Refresh theme position
  if not bolFirstRefresh then
    FadeInOut(true);
end;

// =====================================

procedure TfrmMenu.dynimgCustomImageClick(Sender: TObject);
// Handle a click event on a dynamic image by taking the app to execute from the path and executing it
begin
  if TImage(Sender).Hint <> '' then
    RunExe(TImage(Sender).Hint);
end;

procedure TfrmMenu.CustomImageExitClick(Sender: TObject);
// Handle a click event on a dynamic image by taking the app to execute from the path and executing it
begin
  strCustomImageExitPath := TImage(Sender).Hint;
  bolVisible:=false;
  bolFadeToExit:=true;
  FadeInOut(false);
end;

// =====================================

function TfrmMenu.OffsetToInt(strInteger : String; intDenominator : Integer) : Integer;
// Convert a string to an integer, even if it's a percentage value
begin
  if RightStr(strInteger, 1)='%' then
    result:=Round(intDenominator * (StrToInt(LeftStr(strInteger, Length(strInteger)-1)) / 100))
  else
    result:=StrToInt(strInteger);
end;

// =====================================

procedure TfrmMenu.OnFormMoving(var Msg: TWMMoving);
// Limit the screen position when dragging, and update offsets (XrXca)
var
  intMaxOffTop: Integer;
  rctMonitor: TRect;
begin
  intMaxOffTop := GetSystemMetrics(SM_CYCAPTION);
  // Keep it on the screen (for the most part)
  rctMonitor := Screen.MonitorFromPoint(msg.DragRect^.TopLeft).WorkareaRect;
  if msg.DragRect^.Right < rctMonitor.left + 75 then
    OffsetRect(msg.DragRect^, rctMonitor.Left + 75 - msg.DragRect^.Right, 0);
  if msg.DragRect^.Top < rctMonitor.top - intMaxOffTop  then
    OffsetRect(msg.DragRect^, 0, rctMonitor.Top - intMaxOffTop - msg.DragRect^.Top + 1);
  rctMonitor := Screen.MonitorFromPoint(msg.DragRect^.BottomRight).WorkareaRect;
  if msg.DragRect^.Left > rctMonitor.Right - 75 then
    OffsetRect(msg.DragRect^, rctMonitor.right - 75 - msg.DragRect^.Left, 0);
  if msg.DragRect^.Top > rctMonitor.Bottom - 75 then
    OffsetRect(msg.DragRect^, 0, rctMonitor.bottom - 75 - msg.DragRect^.Top);
  // Update OffsetX and OffsetY
  if bolSwitchSide then
  begin
    intOffsetX := msg.DragRect^.Left;
    intOffsetY := msg.DragRect^.Top;
  end
  else
  begin
    intOffsetX := msg.DragRect^.Right - Screen.WorkAreaRect.Right;
    intOffsetY := msg.DragRect^.Bottom - Screen.WorkAreaRect.Bottom;
  end;
end;


// =====================================

// ... and that's all folks... (aka app end)
end.
